#pragma TextEncoding = "Windows-1252"
#pragma rtGlobals=3		// Use modern global access method.
//#pragma version=1.17d// decided to not use pragma but a string constant 

// Panel for investigating major ions in HR chemical families High ToF-AMS analysis Toolkit
// Peak Integration by Key Analysis (PIKA)
//Copyright (C) 2005, 2006, 2007,2008, 2009,2010,2011, 2012, 2013, 2014, 2015, 2016, 2017
// Pete DeCarlo, Allison Aiken, Jose Jimenez, Donna Sueper University of Colorado
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
//
///////////////////////////////////////////////////////////////////////////////
// CURRENT STATUS
// see HR read me file for details.

Function HR_butt_ChemSibPanel(ctrlName) : ButtonControl
	String ctrlName

	HR_create_ChemSibPanel()

End


Function HR_create_ChemSibPanel() : Panel

	DoWindow/F HR_ChemSiblingPanel
	if (V_flag==1)
		return 0
	endif
	
	if (!Exists("root:HR_ChemSib:HO"))		// 1.49E  we need to check that some waves used in the new diagnostic plots exist
		abort "Please press the 'Calculate time series for chemical siblings panel on the main pika panel - Diagnostics tab. - aborting from HR_create_ChemSibPanel"
	endif

	PauseUpdate; Silent 1		// building window...
	NewPanel /W=(244,117,1054,701)/N=HR_ChemSiblingPanel as "HR_ChemSiblingPanel"
	ModifyPanel fixedSize=1		//1.57L
	ShowTools/A
	SetDrawLayer UserBack
	SetDrawEnv fsize= 16,fstyle= 1
	DrawText 6,22,"HR Sibling Ion Check v 1.0"
	SetDrawEnv fsize= 16,fstyle= 1,textrot= 90
	DrawText 4,223,"Main Chemical Species"
	SetDrawEnv fsize= 16,fstyle= 1,textrgb= (0,34816,52224),textrot= 90
	DrawText 5,393,"Air, Water"
	SetDrawEnv fsize= 16,fstyle= 1,textrot= 90
	DrawText 4,549,"Aer. Chemistry"
	SetDrawEnv fillpat= 0
	DrawRect 2,30,806,227
	SetDrawEnv linethick= 2,fillpat= 0
	DrawRect 3,406,804,580
	SetDrawEnv linefgc= (0,34816,52224),fillpat= 0
	DrawRect 2,230,805,401
	SetDrawEnv fstyle= 1,textrgb= (65280,0,0)
	DrawText 26,50,"HRSO4"
	SetDrawEnv fstyle= 1,textrgb= (0,15872,65280)
	DrawText 220,50,"HRNO3"
	SetDrawEnv fstyle= 1,textrgb= (52224,34816,0)
	DrawText 420,50,"HRNH4"
	SetDrawEnv textrgb= (0,15872,65280)
	DrawText 25,245,"N2, Ar vs O2"
	SetDrawEnv textrgb= (0,15872,65280)
	DrawText 223,244,"N vs O"
	DrawText 30,421,"Meas. vs Pred. HRNH4"
	SetDrawEnv fstyle= 1,textrgb= (65280,32768,58880)
	DrawText 610,46,"HRCl"
	DrawText 413,245,"H2O vs OH"
	DrawText 615,245,"H2O vs CO2"

	TitleBox title0 pos={230,1}, variable=root:HR_ChemSib:calcInfo,frame=0
//	TitleBox title1 pos={580,1}, variable=root:HR_ChemSib:Info,frame=0
	Button button_CS_AerSibSO4Graph,pos={200,50},size={15,60},proc=sq_butt_popThis,title="p\ro\rp\r<"
	Button button_CS_AerSibNO3Graph,pos={395,50},size={15,60},proc=sq_butt_popThis,title="p\ro\rp\r<"
	Button button_CS_AerSIbNH4Graph,pos={590,50},size={15,60},proc=sq_butt_popThis,title="p\ro\rp\r<"
	Button button_CS_AerSibHClGraph,pos={780,50},size={15,60},proc=sq_butt_popThis,title="p\ro\rp\r<"

	Button button_CS_AerSibAir2Graph,pos={200,245},size={15,60},proc=sq_butt_popThis,title="p\ro\rp\r<"
	Button button_CS_AerSibAir1Graph,pos={395,245},size={15,60},proc=sq_butt_popThis,title="p\ro\rp\r<"
	Button button_CS_AerSibH2OGraph,pos={590,245},size={15,60},proc=sq_butt_popThis,title="p\ro\rp\r<"
	Button button_CS_AerSibH2OCO2Graph,pos={780,245},size={15,60},proc=sq_butt_popThis,title="p\ro\rp\r<"

	Button button_CS_NH4MeasPredGraph,pos={200,420},size={15,60},proc=sq_butt_popThis,title="p\ro\rp\r<"

	Display/W=(25,50,200,225)/HOST=# 
	RenameWindow #,CS_AerSibSO4Graph
	CS_populate_AerSibSO4Graph()
	SetActiveSubwindow ##
	Display/W=(220,50,395,225)/HOST=# 
	RenameWindow #,CS_AerSibNO3Graph
	CS_populate_AerSibNO3Graph()
	SetActiveSubwindow ##
	Display/W=(415,50,590,225)/HOST=# 
	RenameWindow #,CS_AerSIbNH4Graph
	CS_populate_AerSIbNH4Graph()
	SetActiveSubwindow ##
	Display/W=(610,50,780,225)/HOST=# 
	RenameWindow #,HR_AerSibHClGraph
	CS_populate_AerSibHClGraph()
	SetActiveSubwindow ##

	Display/W=(25,245,200,400)/HOST=# 
	RenameWindow #,CS_AerSibAir2Graph
	CS_populate_AerSibAir2Graph()
	SetActiveSubwindow ##
	Display/W=(220,245,395,400)/HOST=# 
	RenameWindow #,CS_AerSibAir1Graph
	CS_populate_AerSibAir1Graph()
	SetActiveSubwindow ##
	Display/W=(415,245,590,400)/HOST=# 
	RenameWindow #,CS_AerSibH2OGraph
	CS_populate_AerSibH2OGraph()
	SetActiveSubwindow ##
	Display/W=(615,245,780,400)/HOST=# 
	RenameWindow #,CS_AerSibH2OCO2Graph
	CS_populate_AerSibH2OCO2Graph()
	SetActiveSubwindow ##

	Display/W=(25,420,200,575)/HOST=# 
	RenameWindow #,CS_NH4MeasPredGraph
	CS_populate_NH4MeasPredGraph()
	SetActiveSubwindow ##

End

Function CS_calcPredictNH4()

	wave HRNH4 = root:HR_ChemSib:HRNH4
	wave HRSO4 = root:HR_ChemSib:HRSO4 
	wave HRNO3 = root:HR_ChemSib:HRNO3
	wave HRChl = root:HR_ChemSib:HRChl
	
	duplicate/o HRNH4 root:HR_ChemSib:HRNH4_predict/ wave=HRNH4_predict
	
	variable mw_so4 = 98
	variable mw_nh4 = 18
	variable mw_no3 = 63
	variable mw_chl = 35		

	HRNH4_predict = (2*mw_nh4/mw_so4)*HRSO4 + (mw_nh4/mw_no3)*HRNO3 + (mw_nh4/mw_chl)*HRChl

End


Function CS_butt_CalcSibCheckWaves(ctrlName) : ButtonControl
	string ctrlName
	
	nvar HR_checkConvertTougm3= root:HR_panel:HR_checkConvertTougm3
	nvar HR_checkUseAB = root:HR_panel:HR_checkUseAB
	svar todoStr=root:panel:sq_toDoWvNm
	wave/z todo=$"root:"+todoStr			//1.44B

	string paramStr="", speclistStr, dummyStr, spectraType, specTypeInitial, Xion
	variable idex, num
		
 	ControlInfo/W=HR_Analysis_Panel HRResults_pop_dataSet
	if (stringMatch(S_Value, "Initialize") || stringMatch(S_Value, "Get List"))
		abort "Please select the data type from the drop down menu."
	else
		spectraType=S_Value
	endif
	if (!stringmatch(spectraType[0,1], "HR"))		//PToF
		abort "This is not yet possible. - Aborting from HROrgCheck_calcfCO2fCHO"
	else			//MS
		if (   strsearch(spectraType, "OMinusC", 0)   >=0	) 
			specTypeInitial="M"
		else 
			specTypeInitial=spectraType[2]		//i.e. HROpenStick
		endif
	endif

	NewDataFolder/o root:HR_ChemSib
	
	svar HRResults_ionList = root:HR_panel:HRResults_ionList
	HRResults_ionList = "HROrg,HRNO3,HRSO4,HRNH4,HRChl,"
	HRResults_ionList += "NO,NO2,SO,SO2,SO3,NH2,NH3,Cl,HCl,"
	HRResults_ionList += "N,N2,O,O2,Ar,HO,H2O,CO2,"
	
	speclistStr = HRResults_ionList

	HR_GetParamStr(paramstr,speclistStr,0,3)
	paramStr+="filter_op:0;"
	paramStr+="corr_op:"+num2str(HR_checkUseAB)+";"
	paramstr+="ug_op:"+num2str(HR_checkConvertTougm3)+";"		// always do in units of g/m3
	paramstr+="cache_op:"+num2str(0)+";"
	paramstr+="product_type:1;"
	paramstr+="destList:"+ReplaceString(",", HRResults_ionList, "_"+specTypeInitial+"_temp/")

	HR_calc_MSVsTime("temp", spectraType, specTypeInitial, paramstr, "")
	
	num = itemsInList(HRResults_ionList,",")
	for(idex=0;idex<num;idex+=1)
		Xion = stringFromList(idex, HRResults_ionList, ",")
		wave X_temp = $"root:"+Xion+"_"+specTypeInitial+"_temp"
		duplicate/o X_temp $"root:HR_ChemSib:"+Xion
		killwaves/z X_temp
	endfor
	
	CS_calcPredictNH4()
	HRResults_ionList=""
	string/g root:HR_chemSib:calcInfo="Calculations:\r"
	svar calcInfo = root:HR_chemSib:calcInfo
	calcInfo+="todo:"+todoStr+";"
	calcInfo+="units:"+selectString(HR_checkConvertTougm3, "Hz", "ug/m3")+";"
	calcInfo+="dataset:"+spectraType+";"
	calcInfo+="AB corr used?:"+selectString(HR_checkUseAB, "N", "Y")+";"
End


//////////////////////////////////////////  populate functions
Function CS_standardGraph()
	ModifyGraph grid=2,gridRGB=(34816,34816,34816)  //1.56E
	SetAxis/A/E=3 left		//1.51A
	SetAxis/A/E=3 bottom	//1.51A		//1.56F
	ModifyGraph mode=2,lsize=2
	ModifyGraph zero=1
End

Function CS_populate_AerSibSO4Graph()
	wave/z SO = root:HR_ChemSib:SO 
	wave/z SO2 = root:HR_ChemSib:SO2 
	wave/z SO3 = root:HR_ChemSib:SO3 
	if (!WaveExists(SO2) || !WaveExists(SO)  || !WaveExists(SO3) )
		return 0
	endif
	AppendToGraph SO2, SO3 vs SO
	ModifyGraph  rgb(SO2)=(58880,0,0)
	ModifyGraph  rgb(SO3)=(44032,29440,58880)
	svar calcInfo = root:HR_chemSib:calcInfo
	Label left "\\Z12 SOx, "+StringByKey("units",calcInfo)
	Label bottom "\\Z12SO, "+StringByKey("units",calcInfo)
	CS_standardGraph()
	make/o/free/wave grWaves = {SO2,SO3, SO}
	CS_DrawXto1(grWaves,1,0)
	CS_DrawXto1(grWaves,0.5,3)
	CS_DrawXto1(grWaves,0.25,5)
End

Function CS_populate_AerSibNO3Graph()
	wave/z NO = root:HR_ChemSib:NO 
	wave/z NO2 = root:HR_ChemSib:NO2 
	if (!WaveExists(NO2) || !WaveExists(NO)  )
		return 0
	endif
	AppendToGraph NO2, vs NO
	ModifyGraph  zColor(NO2)={root:index:t_series,*,*,Rainbow}
	svar calcInfo = root:HR_chemSib:calcInfo
	Label left "\\Z12 NO2, "+StringByKey("units",calcInfo)
	Label bottom "\\Z12NO, "+StringByKey("units",calcInfo)
	CS_standardGraph()
	make/o/free/wave grWaves = {NO,NO2}
	CS_DrawXto1(grWaves,1,0)
End

Function CS_populate_AerSIbNH4Graph()
	wave/z NH2 = root:HR_ChemSib:NH2 
	wave/z NH3 = root:HR_ChemSib:NH3 
	if (!WaveExists(NH2) || !WaveExists(NH3) )
		return 0
	endif
	AppendToGraph NH3 vs NH2
	ModifyGraph  zColor(NH3)={root:index:t_series,*,*,Rainbow}
	svar calcInfo = root:HR_chemSib:calcInfo
	Label left "\\Z12 NH3, "+StringByKey("units",calcInfo)
	Label bottom "\\Z12NH2, "+StringByKey("units",calcInfo)
	CS_standardGraph()
	make/o/free/wave grWaves = {NH2,NH3}
	CS_DrawXto1(grWaves,1, 0)
	CS_DrawXto1(grWaves, 1.1, 2)
End

Function CS_populate_AerSibHClGraph()
	wave/z Cl = root:HR_ChemSib:Cl 
	wave/z HCl = root:HR_ChemSib:HCl 
	if (!WaveExists(Cl) || !WaveExists(HCl)  ) 
		return 0
	endif
	AppendToGraph HCl vs Cl
	ModifyGraph zColor(HCl)={root:index:t_series,*,*,Rainbow}
	svar calcInfo = root:HR_chemSib:calcInfo
	Label left "\\Z12 HCl, "+StringByKey("units",calcInfo)
	Label bottom "\\Z12Cl, "+StringByKey("units",calcInfo)
	CS_standardGraph()
End

Function CS_populate_AerSibAir2Graph()
	wave/z O2 = root:HR_ChemSib:O2
	wave/z N2 = root:HR_ChemSib:N2
	wave/z Ar = root:HR_ChemSib:Ar
	if (!WaveExists(O2) || !WaveExists(N2)  ) 
		return 0
	endif
	AppendToGraph Ar,O2 vs N2
	ModifyGraph  rgb(Ar)=(43520,43520,43520)
	ModifyGraph  rgb(O2)=(26112,17408,0)
	svar calcInfo = root:HR_chemSib:calcInfo
	Label left "\\Z12 Ar, O2, "+StringByKey("units",calcInfo)
	Label bottom "\\Z12N2, "+StringByKey("units",calcInfo)
	CS_standardGraph()
End

Function CS_populate_AerSibAir1Graph()
	wave/z O = root:HR_ChemSib:O
	wave/z N = root:HR_ChemSib:N
	if (!WaveExists(O) || !WaveExists(N)  ) 
		return 0
	endif
	AppendToGraph O vs N
	ModifyGraph  zColor(O)={root:index:t_series,*,*,Rainbow}
	svar calcInfo = root:HR_chemSib:calcInfo
	Label left "\\Z12 O, "+StringByKey("units",calcInfo)
	Label bottom "\\Z12N, "+StringByKey("units",calcInfo)
	CS_standardGraph()
End

Function CS_populate_AerSibH2OGraph()
	wave/z H2O = root:HR_ChemSib:H2O
	wave/z HO= root:HR_ChemSib:HO
	if (!WaveExists(H2O) || !WaveExists(HO)  ) 
		return 0
	endif
	AppendToGraph  HO vs H2O
	ModifyGraph zColor(HO)={root:index:t_series,*,*,Rainbow}
	svar calcInfo = root:HR_chemSib:calcInfo
	Label left "\\Z12 HO, "+StringByKey("units",calcInfo)
	Label bottom "\\Z12H2O, "+StringByKey("units",calcInfo)
	CS_standardGraph()
End

Function CS_populate_AerSibH2OCO2Graph()
	wave/z H2O = root:HR_ChemSib:H2O
	wave/z CO2= root:HR_ChemSib:CO2
	if (!WaveExists(H2O) || !WaveExists(CO2)  ) 
		return 0
	endif
	AppendToGraph  CO2 vs H2O
	ModifyGraph zColor(CO2)={root:index:t_series,*,*,Rainbow}
	svar calcInfo = root:HR_chemSib:calcInfo
	Label left "\\Z12 CO2, "+StringByKey("units",calcInfo)
	Label bottom "\\Z12H2O, "+StringByKey("units",calcInfo)
	CS_standardGraph()
End

Function CS_populate_NH4MeasPredGraph()
	wave/z HRNH4 = root:HR_ChemSib:HRNH4
	wave/z HRNH4_predict= root:HR_ChemSib:HRNH4_predict
	if (!WaveExists(HRNH4) || !WaveExists(HRNH4_predict)  ) 
		return 0
	endif
	AppendToGraph  HRNH4 vs HRNH4_predict
	ModifyGraph zColor(HRNH4)={root:index:t_series,*,*,Rainbow}
	svar calcInfo = root:HR_chemSib:calcInfo
	Label left "\\Z12 HRNH4, "+StringByKey("units",calcInfo)
	Label bottom "\\Z12HRNH4_predict, "+StringByKey("units",calcInfo)
	CS_standardGraph()
	make/o/free/wave grWaves = {HRNH4,HRNH4_predict}
	CS_DrawXto1(grWaves,1,0)
End


Function CS_DrawXto1(grWaves, slope, dashType)
wave/wave grWaves
variable slope, dashType

	variable idex, num, myMin=INF,myMax=-INF
	num=numpnts(grWaves)
	for (idex=0; idex<num;idex+=1)
		wave w =grWaves[idex]
		mymin = min(mymin, WaveMin(w) )
		mymax = max(mymax, WaveMax(w) )
	endfor
	SetDrawEnv xcoord= bottom,ycoord= left,dash=dashType
	DrawLine mymin, mymin, mymax, mymax*slope
End


///////////////////////////////////////////////////////////////////////////////////////////////////////
// Additions in 1.20S
// These PAHs were listed in Herring et al, AS&T, 2015 for diesel and gasoline exhaust analysis
STRCONSTANT UnSubPAHLIST="C10H8;C12H8;C12H10;C13H10;C14H8;C14H10;C15H10;C16H10;C17H12;C18H10;C18H12;C20H10;C20H12;C22H12;C22H14;"
STRCONSTANT OPAHLIST="C9H8O;C11H8O;C10H6O2;C12H8O;C13H8O;C13H10O;C12H6O2;C12H8O2;C14H10O;C13H8O2;C15H8O;C14H8O2;C16H8O2;C19H10O;C18H10O2;"
STRCONSTANT MPAHLIST="C11H10;C12H12;C13H12;C14H12;C15H12;C15H14;C16H14;C17H16;C18H18;C19H14;C20H16;C21H16;"
STRCONSTANT NPAHLIST="C10H7NO2;C12H9NO2;C13H9NO2;C14H9NO2;C16H9NO2;C13H8N2O4;C18H11NO2;"
STRCONSTANT APAHLIST="C16H11N;C18H13N;C20H13N;C21H13N;"

// RGB colors
STRCONSTANT UnSubPAHRGB="52428;34958;1"	// gold
STRCONSTANT OPAHRGB="52428;1;41942"		// fuscia
STRCONSTANT MPAHRGB="23901;29298;52428" // grayish blue
STRCONSTANT NPAHRGB="19729;1;39321"		// dark purple
STRCONSTANT APAHRGB="52428;1;1"		// brick red


Function HR_butt_AddPAHLists(ctrlName) : ButtonControl
string ctrlName

	string FullList
	make/n=0/free mWave
	FullList = pk_ExpandFamilyBase("UnSubPAH", UnSubPAHLIST, 1, 0, 1, mWave)
	HR_butt_AddfamilyViaLists("UnSubPAH", UnSubPAHRGB, UnSubPAHLIST, FullList, 1, 1, 0, 1, mWave)								
	FullList = pk_ExpandFamilyBase("OPAH",OPAHLIST, 1, 0, 1, mWave)
	HR_butt_AddfamilyViaLists("OPAH", OPAHRGB, OPAHLIST, FullList, 1, 1, 0, 1, mWave)								
	FullList = pk_ExpandFamilyBase("MPAH", MPAHLIST, 1, 0, 1, mWave)
	HR_butt_AddfamilyViaLists("MPAH", MPAHRGB, MPAHLIST, FullList, 1, 1, 0, 1, mWave)									
	FullList = pk_ExpandFamilyBase("NPAH", NPAHLIST, 1, 0, 1, mWave)
	HR_butt_AddfamilyViaLists("NPAH", NPAHRGB, NPAHLIST, FullList, 1, 1, 0, 1, mWave)									
	FullList = pk_ExpandFamilyBase("APAH", APAHLIST, 1, 0, 1, mWave)
	HR_butt_AddfamilyViaLists("APAH", APAHRGB, APAHLIST, FullList, 1, 1, 0, 1, mWave)								

	wave/t HR_specName_List = root:HR_frag:HR_specName_List
	wave/t HR_spec_List = root:HR_frag:HR_spec_List
	wave/t HR_specFrag_List = root:HR_frag:HR_specFrag_List
	wave/t HR_specFamilyBase = root:HR_frag:HR_specFamilyBase
	wave/t HR_specFamilyExceptions = root:HR_frag:HR_specFamilyExceptions
	wave HR_specIEFac_list = root:HR_frag:HR_specIEFac_list
	wave HR_specCalFac_list = root:HR_frag:HR_specCalFac_list
	wave HR_specCEfac_list = root:HR_frag:HR_specCEfac_list
	wave/t HR_CEWave_List = root:HR_frag:HR_CEWave_List
	wave/t HR_specCorr_list = root:HR_frag:HR_specCorr_list
	wave HR_specColor_R = root:HR_frag:HR_specColor_R
	wave HR_specColor_G = root:HR_frag:HR_specColor_G
	wave HR_specColor_B = root:HR_frag:HR_specColor_B
	
	variable pos, numS
// update species table			
	pos = sq_findStr(HR_specName_List,"HRPAHSum",1)
	numS = numpnts(HR_specName_List)
	
	if (pos<0)	
		insertpoints numS, 1, HR_specName_List; 	HR_specName_List[numS]="HRPAHSum"
		insertpoints numS, 1, HR_spec_List; 		HR_spec_List[numS]="HRPAHSum"
		insertpoints numS, 1, HR_specFrag_List; 	HR_specFrag_List[numS]="HR_frag_HRPAHSum"
		insertpoints numS, 1, HR_specFamilyBase; 	HR_specFamilyBase[numS]="familyUnSubPAH;familyOPAH;familyMPAH;familyNPAH;familyAPAH;"
		insertpoints numS, 1, HR_specFamilyExceptions; 	HR_specFamilyExceptions[numS]=""
		insertpoints numS, 1, HR_specIEFac_list; 	HR_specIEFac_list[numS]=1.4	// same default as HROrg, this is an assumption
		insertpoints numS, 1, HR_specCalFac_list; //	HR_specCalFac_list[num]=		// should be calced automatically.  This line would break the dependency
		insertpoints numS, 1, HR_specCEfac_list; 	HR_specCEfac_list[numS]=1
		insertpoints numS, 1, HR_CEWave_List; 		HR_CEWave_List[numS]=""
	
		insertpoints numS, 1, HR_specCorr_list; 	HR_specCorr_list[numS]=""
		insertpoints numS, 1, HR_specColor_R; 		HR_specColor_R[numS]=0
		insertpoints numS, 1, HR_specColor_G; 		HR_specColor_G[numS]=0
		insertpoints numS, 1, HR_specColor_B; 		HR_specColor_B[numS]=0	
		duplicate/o/t root:HR_frag:HR_frag_chloride root:HR_frag:HR_frag_HRPAHSum/wave=HR_frag_HRPAHSum 
		HR_frag_HRPAHSum=""
	endif

	HR_change2FitHRIon($"Root:HR:familyWave_UnSubPAH",1)
	HR_change2FitHRIon($"Root:HR:familyWave_OPAH",1)
	HR_change2FitHRIon($"Root:HR:familyWave_MPAH",1)
	HR_change2FitHRIon($"Root:HR:familyWave_NPAH",1)
	HR_change2FitHRIon($"Root:HR:familyWave_APAH",1)

	HR_butt_MakeExactMassWaves("")
End


Function HR_butt_AddfamilyViaLists(FamName, FamRGB, FamBaseList, FamBigList, HROrgFlag, LessHflag, Less2Hflag, IsoFlag, massWave)
string FamName, FamRGB, FamBaseList, FamBigList
variable HROrgFlag, LessHflag, Less2Hflag, IsoFlag
wave massWave

	wave/t HR_specName_List = root:HR_frag:HR_specName_List
	wave/t HR_spec_List = root:HR_frag:HR_spec_List
	wave/t HR_specFrag_List = root:HR_frag:HR_specFrag_List
	wave/t HR_specFamilyBase = root:HR_frag:HR_specFamilyBase
	wave/t HR_specFamilyExceptions = root:HR_frag:HR_specFamilyExceptions
	wave HR_specIEFac_list = root:HR_frag:HR_specIEFac_list
	wave HR_specCalFac_list = root:HR_frag:HR_specCalFac_list
	wave HR_specCEfac_list = root:HR_frag:HR_specCEfac_list
	wave/t HR_CEWave_List = root:HR_frag:HR_CEWave_List
	
	wave/t HR_specCorr_list = root:HR_frag:HR_specCorr_list
	wave HR_specColor_R = root:HR_frag:HR_specColor_R
	wave HR_specColor_G = root:HR_frag:HR_specColor_G
	wave HR_specColor_B = root:HR_frag:HR_specColor_B

 	wave/t HR_familyName = root:HR:HR_familyName
	wave/t HR_familyListDefinition = root:HR:HR_familyListDefinition
	wave HR_family_R = root:HR:HR_family_R
	wave HR_family_G = root:HR:HR_family_G
	wave HR_family_B = root:HR:HR_family_B

	variable idex, jdex, numF, numS, pos, numBigLists
	string PAHName, PAHsList, RGBList, HROrgFamList
	
	// before we start make sure the batch and family tables make sense
	numS = numpnts(HR_specName_List)
	if (numS!=numpnts(HR_spec_List) || numS!=numpnts(HR_specFrag_List) || numS!=numpnts(HR_specFamilyBase) || numS!=numpnts(HR_specFamilyExceptions) || numS!=numpnts(HR_specIEFac_list) || numS!=numpnts(HR_specCalFac_list) )	// broken into separate lines for easier editing	
	 	if (numS!=numpnts(HR_specCEfac_list) || numS!=numpnts(HR_CEWave_List) || numS!=numpnts(HR_specCorr_list) || numS!=numpnts(HR_specColor_R) || numS!=numpnts(HR_specColor_G) || numS!=numpnts(HR_specColor_B) )
			HR_butt_HRbatchTable("")
			abort "The number of points in the different waves in the HR batch table is different - please fix before proceeding.  aborting from HR_butt_AddPAHLists" 
		endif
	endif

	numF = numpnts(HR_familyName)
	if (numF!=numpnts(HR_familyListDefinition) || numF!=numpnts(HR_family_R) || numF!=numpnts(HR_family_G) || numF!=numpnts(HR_family_B) )
		HR_butt_ViewFamilyTable("")
		abort "The number of points in the different waves in the HR family table is different - please fix before proceeding.  Aborting from HR_butt_AddPAHLists" 
	endif
		
	Make/o/t/n=(ItemsInList(FamBigList)) $"root:HR:familyWave_"+FamName/wave=family
	family= stringFromList(p, FamBigList)
	Note/K family
	Note family, "BaseList:" +FamBaseList+"/LessHflag:"+num2istr(LessHflag)+"/Less2Hflag:"+num2istr(Less2Hflag)+"/Isoflag:"+num2istr(Isoflag)

	pos = sq_findStr(HR_familyName,famName,1)
	if (pos<0)
		insertpoints numF, 1, HR_familyName; 	HR_familyName[numF]=FamName
		insertpoints numF, 1, HR_familyListDefinition; 	HR_familyListDefinition[numF]="familyWave_"+FamName
		insertpoints numF, 1, HR_family_R; 	HR_family_R[numF]=str2num(stringFromList(0,FamRGB))
		insertpoints numF, 1, HR_family_G; 	HR_family_G[numF]=str2num(stringFromList(1,FamRGB))
		insertpoints numF, 1, HR_family_B; 	HR_family_B[numF]=str2num(stringFromList(2,FamRGB))	
	endif

// unlike UMR we can have HROrg species which include PAHs AND a separate PAH species
	// change HROrg species to include PAH families
	pos = sq_findStr(HR_spec_List,"HROrg",1)
	if (pos>=0)		// should always be here
		HROrgFamList=HR_specFamilyBase[pos]
		HROrgFamList = ReplaceString(",", HROrgFamList, ";")
		HROrgFamList = ReplaceString(" ", HROrgFamList, "")
		HROrgFamList = gen_AddOrRemoveLastChar(HROrgFamList,";", 1)
		jdex = WhichListItem("family"+FamName, HROrgFamList)
		if (HROrgFlag)
			if (jdex<0)
				HR_specFamilyBase[pos]=HROrgFamList+"family"+FamName+";"
			endif
		elseif(!HROrgFlag)
			string list = HR_specFamilyBase[pos]
			list = RemoveFromList("family"+FamName, list)
			HR_specFamilyBase[pos]=list
		endif
	endif

	numF = numpnts(family)  // 1.21A
	make/free/n=(numF) familyMass
	for(idex=0;idex<numF;idex+=1)
		familyMass[idex] = PK_FindMassFromFormula(family[idex])
	endfor
	sort familyMass, familyMass,family

End


// 1.20S  These functions were added in coordination with PAH family waves.
Function PK_AddTheseHRIonsToAll(HRionChemNameWave)
wave/t HRionChemNameWave

	HR_MassCalcGlobals()

	svar NewHRIonQueryText = root:HR_panel:NewHRIonQueryText
	nvar NewHRIonQueryMass = root:HR_panel:NewHRIonQueryMass

	nvar NewHRIonQueryFindExists = root:HR_panel:NewHRIonQueryFindExists
	nvar NewHRIonQueryFindChildChosen = root:HR_panel:NewHRIonQueryFindChildChosen
	nvar HR_isotopeLowerLimit = root:HR_panel:HR_isotopeLowerLimit
	
	wave/t IsoChildToAllNames = root:HR_Panel:IsoChildToAllNames
	wave IsoChildToAllMass =  root:HR_Panel:IsoChildToAllMass
	wave IsoChildToAllAbund = root:HR_Panel:IsoChildToAllAbund
	wave/t IsoChildToAllParent =  root:HR_Panel:IsoChildToAllParent	// text wave of HR isotopic parents
	
	string HRIonName
	variable idex, num = numpnts(HRionChemNameWave)
	
	HR_checkProc_massCalc("MCalc_ck_IsoNotExistInAll",1)	// mimic radio button push that we look for HR ions that do not exist
	HR_isotopeLowerLimit=0.01		// hard coded
	
	for (idex=0;idex<num;idex+=1)
		NewHRIonQueryText = HRionChemNameWave[idex]
		HR_checkProc_massCalc("MCalc_ck_IsoNotExistInAll",1)  //1.21A
		HR_butt_CalcMassOneHRIon("")  // gold button on calc
		if (numtype(NewHRIonQueryMass) == 0)		
			HR_addThisMass(NewHRIonQueryText,NewHRIonQueryMass)  //1.21B
//			HR_addThisMass(NewHRIonQueryText, NewHRIonQueryMass, [possibleIsotopAbund, possibleIsotopParent, possibleChooseToFit]) // HR_butt_AddThisHRIon("MCalc_butt_AddHRIon")  // 1.21A
		//	HR_addThisMass(NewHRIonQueryText, NewHRIonQueryMass, possibleChooseToFit=0)
		//	HR_AddWavesToAll(IsoChildToAllNames, IsoChildToAllMass, IsoAbundWave=IsoChildToAllAbund, IsoParentWave=IsoChildToAllParent, ChooseToFit=0, DontUpdateChosen=0)
			if (numpnts(IsoChildToAllNames)>0)
				HR_AddWavesToAll(IsoChildToAllNames, IsoChildToAllMass, IsoAbundWave=IsoChildToAllAbund, IsoParentWave=IsoChildToAllParent)
//				HR_butt_AddListToAll("MCalc_butt_AddToall") 
			endif
		else
			print "// Had problems identifying the chemical mass of the HR ion fragment "+NewHRIonQueryText
		endif
	endfor
	
	HR_butt_MakeExactMassWaves("")
End


Function/s pk_GetFamList()
	string list = gen_GetWaveListInDF("root:HR", "familyWave_*")
	list = ReplaceString("familyWave_",list,"")
	list = "\""+gen_AddOrRemoveLastChar(list,";", 1)+"Get List"+ "\""
	return list
End


Function HR_popMenu_FamilyOnlyList(pa) : PopupMenuControl
	STRUCT WMPopupAction &pa

	switch( pa.eventCode )
		case 2: // mouse up
			Variable popNum = pa.popNum
			String popStr = pa.popStr
			if (stringMatch(popStr, "Get List") )		//1.07A changed the name of this popup
				PopupMenu Fami_popup_viewFamilyOnly, value=#pk_GetFamList(), proc=HR_popMenu_FamilyOnlyList
			else // a family wave was chosen
				wave/t HR_specFamilyBase = root:HR_frag:HR_specFamilyBase
				wave/t HR_spec_List = root:HR_frag:HR_spec_List
				wave/t HR_familyName = root:HR:HR_familyName
				wave/z HR_family_R = root:HR:HR_family_R
				wave/z HR_family_G = root:HR:HR_family_G
				wave/z HR_family_B = root:HR:HR_family_B
				svar HR_familyWaveOnlyName =$"root:HR_Panel:HR_familyWaveOnlyName"	
				svar HR_familyWaveOnlyMembers = $"root:HR_Panel:HR_familyWaveOnlyMembers"	
				svar HR_familyWaveOnlyCList = $"root:HR_Panel:HR_familyWaveOnlyCList"
				wave/t/z familyWave = $"root:HR:familyWave_"+popStr
				if (!WaveExists(familyWave))
					HR_familyWaveOnlyMembers=""
					Checkbox Famil_ck_partOfHROrg value = 0
					Checkbox Famil_ck_LessH value = 0
					Checkbox Famil_ck_Less2H value = 0
					Checkbox Famil_ck_isotopes value = 0
				else
					HR_familyWaveOnlyName=popStr
					string wnote = Note(familyWave) 
					string HRlist = StringByKey("BaseList", Note(familyWave), ":", "/")  
					HR_familyWaveOnlyMembers = HRlist
					// has this family been listed in family table before?					
					FindValue/TXOP = 4/TEXT=HR_familyWaveOnlyName HR_familyName
					if (V_Value>=0)
						HR_familyWaveOnlyCList = num2istr(HR_family_R[V_Value])+";"+num2istr(HR_family_G[V_Value])+";"+num2istr(HR_family_B[V_Value])+";"
					endif				
					variable pos = sq_findStr(HR_spec_List,"HROrg",1)
					string HROrgFamily =  HR_specFamilyBase[pos]
					Checkbox Famil_ck_partOfHROrg value =  WhichListItem("family"+HR_familyWaveOnlyName, HROrgFamily)>=0
					Checkbox Famil_ck_LessH value =  str2num(StringByKey("LessHflag", wnote, ":", "/"))
					Checkbox Famil_ck_Less2H value =  str2num(StringByKey("Less2Hflag", wnote ,":", "/"))
					Checkbox Famil_ck_isotopes value =  str2num(StringByKey("IsoFlag", wnote ,":", "/"))
				endif
			
			endif		
			break
	endswitch

	return 0
End


Function HR_butt_ViewFamilyWaveTable(ctrlName) : ButtonControl
	String ctrlName

	DoWindow/F HR_FamilyWaveTable
	string flist = gen_GetWaveListInDF("root:HR", "familyWave_*")
	if (V_flag == 0)
		Edit/W=(5.25,42.5,624.75,490.25)/N=HR_FamilyWaveTable as "HR_FamilyWaveTable"
	endif
	variable idex, num = itemsInList(flist)
	for(idex=0;idex<num;idex+=1)
		AppendToTable $"root:HR:"+StringFromList(idex, flist)
	endfor

End


Function HR_butt_newFamily(ctrlName) : ButtonControl
	String ctrlName

	svar HR_familyWaveOnlyList =$"root:HR_Panel:HR_familyWaveOnlyList"
	svar HR_familyWaveOnlyMembers = $"root:HR_Panel:HR_familyWaveOnlyMembers"
	svar HR_familyWaveOnlyCList = $"root:HR_Panel:HR_familyWaveOnlyCList"
	svar HR_familyWaveOnlyName =$"root:HR_Panel:HR_familyWaveOnlyName"	
	variable idex, num, IsoFlag, LessHflag, Less2Hflag, HROrgFlag, PeriodicTableFlag
	string FullList, str, HRstr
	
	HR_familyWaveOnlyList = ReplaceString("familyWave_", gen_GetWaveListInDF("root:HR", "familyWave_*"), "" )
	HR_familyWaveOnlyMembers = gen_removeEmptiesFromList(ReplaceString(",", ReplaceString(" ", HR_familyWaveOnlyMembers, ""), ";"), ";")
	HR_familyWaveOnlyCList = ReplaceString(",", ReplaceString(" ", HR_familyWaveOnlyCList, ""), ";")

	if (strlen(HR_familyWaveOnlyName)==0 || stringmatch(HR_familyWaveOnlyName, "X"))  //1.21A
		abort "Please enter a sensible name for the new family - to the right of the gold button."
	endif
	
	HR_familyWaveOnlyName = CleanupName(HR_familyWaveOnlyName, 0 )
	if (WhichListItem(HR_familyWaveOnlyName, HR_familyWaveOnlyList)>=0)
		DoAlert 1,  "Do you wish to overwrite the existing familyWave "+HR_familyWaveOnlyName+"?"
		if (V_flag==2)
			return 0
		endif
	endif
	if (ItemsInList(HR_familyWaveOnlyMembers) == 0)
		Abort "There must be more than one HR ion in the list to create or overwrite a family name."
	endif
	num = ItemsInList(HR_familyWaveOnlyCList)  
	if(num != 3)
		HR_familyWaveOnlyCList = "0;0;0;"
	endif

	for(idex=0;idex<itemsInList(HR_familyWaveOnlyMembers);idex+=1)
		str = stringFromList(idex,HR_familyWaveOnlyMembers)
		PeriodicTableFlag = HR_OneHRIonElementalComp(str)
		
		if (PeriodicTableFlag==0)
			abort "The entry in the list '"+str+"' doesn't not appear to be a valid chemical formula.  Please fix."
		else
			HRstr= PK_SortHRionTextByCHNSO(str)
			if (!stringMatch(str, HRstr) )
				DoAlert 1,  "The entry in the list "+str+" is not in atomic element order, it should be "+HRstr+".  Substitute the correct HR ion name and continue?"
				if (V_flag==1)
					HR_familyWaveOnlyMembers = RemoveListItem(idex, HR_familyWaveOnlyMembers)
					HR_familyWaveOnlyMembers = AddListItem(HRstr, HR_familyWaveOnlyMembers, ";", idex)
				else
					return 0
				endif
			endif
		endif
	endfor
		
	ControlInfo Famil_ck_isotopes; IsoFlag=V_Value
	ControlInfo Famil_ck_LessH; LessHflag=V_Value
	ControlInfo Famil_ck_Less2H; Less2Hflag=V_Value
	ControlInfo Famil_ck_partOfHROrg; HROrgFlag=V_Value
	
	make/free/n=(0)  massWave 
	FullList = pk_ExpandFamilyBase(HR_familyWaveOnlyName, HR_familyWaveOnlyMembers, LessHflag, Less2Hflag, IsoFlag, massWave)

	HR_butt_AddfamilyViaLists(HR_familyWaveOnlyName, HR_familyWaveOnlyCList, HR_familyWaveOnlyMembers, FullList, HROrgFlag, LessHflag, Less2Hflag, IsoFlag, massWave)								
			
End


Function/s pk_ExpandFamilyBase(FamName, HRList, LessHflag, Less2Hflag, IsoFlag, massWave)
string FamName, HRList
variable LessHflag, Less2Hflag, IsoFlag
wave &massWave

	wave/d ExactMassText_all = root:HR:ExactMassText_all	
	svar HR_familyWaveOnlyMembers = $"root:HR_Panel:HR_familyWaveOnlyMembers"
	svar NewHRIonQueryText = root:HR_panel:NewHRIonQueryText
	nvar NewHRIonQueryFindExists = root:HR_panel:NewHRIonQueryFindExists
	nvar NewHRIonQueryFindChildChosen = root:HR_panel:NewHRIonQueryFindChildChosen
	nvar HR_isotopeLowerLimit = root:HR_panel:HR_isotopeLowerLimit
	nvar NewHRIonQueryMass = root:HR_panel:NewHRIonQueryMass
	nvar NewHRIonQueryChooseToFit = root:HR_panel:NewHRIonQueryChooseToFit
	nvar NewHRIonQueryIsoAbundance = root:HR_panel:NewHRIonQueryIsoAbundance
	svar NewHRIonQueryIsoParent = root:HR_panel:NewHRIonQueryIsoParent

	if (HR_isotopeLowerLimit< 0.001)		// hard coded
		DoAlert 1, "The lower isotope limit is "+num2str(HR_isotopeLowerLimit)+"  Do you wish to use this value (select yes) or default to 0.001 (no)?"
		if (V_flag==2)  // no
			HR_isotopeLowerLimit=0.001		// hard coded
		endif
	endif	
//	NewHRIonQueryChooseToFit=0
//	HR_checkProc_massCalc("MCalc_ck_IsoNotExistInAll",1)  // simulate pressing button to find HR ions that do not exist
	
	string relations, HRstr, ExpandedList = "", badList = "", IsoList, IsoStr
	variable PeriodicTableFlag, NumNew, NumIso, idex,jdex, kdex, num, counter=0, existsFlag, numkids
	
	make/n=0/free/d tempMass
	num = itemsInLIst(HRList)
	redimension/n=(100*num) massWave   //1.21A  // 100 an estimate... how many HR ions do we expect to generate per HR ion listed
	make/n=0/d/free mWave
	for(idex=0;idex<num;idex+=1)  // for each HR ion in the user provided list
		HRStr = stringFromLIst(idex, HRList)
		NewHRIonQueryText = HRstr
		NewHRIonQueryText = PK_SortHRionTextByCHNSO(NewHRIonQueryText)
		HR_butt_CalcMassOneHRIon("")
//		NewHRIonQueryMass = pk_FindMassFromFormula(NewHRIonQueryText)
//		existsFlag = sq_TextIntextWave(NewHRIonQueryText, ExactMassText_all)>=0
		PeriodicTableFlag = NewHRIonQueryMass>=0
		existsFlag = sq_TextIntextWave(NewHRIonQueryText, ExactMassText_all)>=0
		if (!existsFlag)
			jdex =sq_TextIntextWave(HRStr, ExactMassText_all)			// exists under another name
			if (jdex>=0)
				print "// These two ions appear to be the same: "+HRStr+" , "+NewHRIonQueryText+"  Proceeding with the ion in the correct order"
			endif			
			HR_addThisMass(NewHRIonQueryText, NewHRIonQueryMass,possibleChooseToFit=0, possibleIsotopParent=NewHRIonQueryIsoParent, possibleIsotopAbund=NewHRIonQueryIsoAbundance)
		endif
		
		ExpandedList += NewHRIonQueryText+";"//  HRStr+";"  HRStr may not be in correct order
		massWave[counter]=NewHRIonQueryMass
		counter+=1

		if (IsoFlag && strsearch(NewHRIonQueryText, "j", 0)<0 )
			wave/t HRnameElementOrder = root:HR_Panel:HRnameElementOrder
			wave HRnameElementOrderIndex = root:HR_Panel:HRnameElementOrderIndex
			wave HRnameElementTotal = root:HR_Panel:HRnameElementTotal
			wave/t NewIsotopeHRIonsParent = root:HR_panel:NewIsotopeHRIonsParent	
			wave/t NewIsotopeHRIonsName= root:HR_panel:NewIsotopeHRIonsName
			wave NewIsotopeHRIonsAbundance = root:HR_panel:NewIsotopeHRIonsAbundance
			PK_SortHRionTextByCHNSO(NewHRIonQueryText)
			HR_getAllIsotopicChildren(HRnameElementOrder, HRnameElementOrderIndex,HRnameElementTotal, HR_isotopeLowerLimit, NewIsotopeHRIonsName, NewIsotopeHRIonsAbundance)
			NumIso = numpnts(NewIsotopeHRIonsName)
			redimension/n=(NumIso) NewIsotopeHRIonsParent, tempMass
			NewIsotopeHRIonsParent = NewHRIonQueryText
			tempMass = pk_FindMassFromFormula(NewIsotopeHRIonsName[p])
			HR_addWavesToAll(NewIsotopeHRIonsName, tempMass, IsoAbundWave=NewIsotopeHRIonsAbundance, IsoParentWave=NewIsotopeHRIonsParent, DontUpdateChosen=0)   // HR_butt_AddListToAll("")  // mimic pressing button in panel
			
			ExpandedList += sq_TextWave2List(NewIsotopeHRIonsName)
			massWave[counter,counter+NumIso-1]= tempMass[p-counter]
			counter+=NumIso
		endif

		// now we basically do all these things again for each of the relations
		redimension/n=0 mWave
		relations = pk_AddChemRelations(HRnameElementOrder,HRnameElementTotal, LessHflag, Less2Hflag, NewHRIonQueryMass, mWave)  // only getsnon-isotopic relatives
		NumNew = ItemsInList(relations)
		if (NumNew>0)
			redimension/n=(NumNew) tempMass
			tempMass = pk_FindMassFromFormula(stringFromList(p, relations))
			ExpandedList += relations
			massWave[counter,counter+NumNew-1]= mWave[p-counter]
			counter+=NumNew
			
			for(kdex=0;kdex<NumNew;kdex+=1)		// for each of the parent ions relatives  - all should be in CHNO... order
				NewHRIonQueryText = stringFromLIst(kdex, relations)
				HR_addThisMass(NewHRIonQueryText, NewHRIonQueryMass,possibleChooseToFit=0)
				if (IsoFlag && strsearch(NewHRIonQueryText, "j", 0)<0 )
					PK_SortHRionTextByCHNSO(NewHRIonQueryText)
					HR_getAllIsotopicChildren(HRnameElementOrder, HRnameElementOrderIndex,HRnameElementTotal, HR_isotopeLowerLimit, NewIsotopeHRIonsName, NewIsotopeHRIonsAbundance)
					NumIso = numpnts(NewIsotopeHRIonsName)
					redimension/n=(NumIso) NewIsotopeHRIonsParent, tempMass
					NewIsotopeHRIonsParent = NewHRIonQueryText
					tempMass = pk_FindMassFromFormula(NewIsotopeHRIonsName[p])
					HR_addWavesToAll(NewIsotopeHRIonsName, tempMass, IsoAbundWave=NewIsotopeHRIonsAbundance, IsoParentWave=NewIsotopeHRIonsParent, DontUpdateChosen=0)   // HR_butt_AddListToAll("")  // mimic pressing button in panel
					
					ExpandedList += sq_TextWave2List(NewIsotopeHRIonsName)
					massWave[counter,counter+NumIso-1]= tempMass[p-counter]
					counter+=NumIso
				endif
			endfor			
		endif			
	endfor

	DeletePoints counter, (100*num), massWave  //1.61B
		
	ExpandedList = gen_sortRemoveDups(ExpandedList, MassWave)
	ExpandedList = pk_EnsureDisjointFam(FamName, ExpandedList, massWave)
		
	return ExpandedList

End


Function/S pk_AddChemRelations(HRnameElementOrder,HRnameElementTotal, LessHflag, Less2Hflag, MassVal, massWave)
wave/t HRnameElementOrder
wave HRnameElementTotal
variable LessHflag, Less2Hflag, MassVal
wave &massWave 

	variable count, Hpos
	string Relations=""
	wave ElementIonMass = root:HR:ElementIonMass
	
	FindValue/Text="H"/TXop=4 HRnameElementOrder
	HPos = V_Value
	
	redimension/n=(LessHflag+Less2Hflag) massWave	
	if (HPos>=0)
		if (LessHflag && HRnameElementTotal[HPos]>=1)
			relations+=pk_ChemFormStr(HRnameElementOrder,HRnameElementTotal,HPos, -1)+";"	
			massWave[0] = MassVal - ElementIonMass[0]		
		endif
		if(Less2Hflag && HRnameElementTotal[HPos]>=2)
			relations+=pk_ChemFormStr(HRnameElementOrder,HRnameElementTotal,HPos, -2)+";"			
			massWave[LessHflag] = MassVal - 2*ElementIonMass[0]	
		endif
	endif
	
	return relations
	
End


Function/s pk_ChemFormStr(HRnameElementOrder,HRnameElementTotal,ElemPos, ElemDelta)
	wave/t HRnameElementOrder
	wave HRnameElementTotal
	variable ElemPos, ElemDelta
	
	string ChemStr = ""
	variable idex
	for (idex=0;idex<numpnts(HRnameElementOrder);idex+=1)
		if(idex==ElemPos)
			if (HRnameElementTotal[idex]+ElemDelta==1)
				ChemStr+= HRnameElementOrder[idex]
			elseif(HRnameElementTotal[idex]+ElemDelta>1)
				ChemStr+= HRnameElementOrder[idex]+num2istr(HRnameElementTotal[idex]+ElemDelta)
			endif
		else
			if (HRnameElementTotal[idex]==1)
				ChemStr+= HRnameElementOrder[idex]
			elseif(HRnameElementTotal[idex]>1)
				ChemStr+= HRnameElementOrder[idex]+num2istr(HRnameElementTotal[idex])
			endif
		endif
	endfor

	return ChemStr
End


Function/s pk_EnsureDisjointFam(NewFamName, NewFamMemList, massWave)
string NewFamName, NewFamMemList
wave massWave

	string flist = gen_GetWaveListInDF("root:HR", "familyWave_*")
	flist = RemoveFromList("familyWave_"+NewFamName, flist)
	string BigList = gen_CombineTextWaves2List(Flist, dfStr="root:HR")
	make/n=(itemsInLIst(BigList))/t/free TextWaveA = stringfromList(p,BigList) 
	make/n=(itemsInLIst(NewFamMemList))/t/free TextWaveB = stringfromList(p,NewFamMemList) 
	make/n=(0)/t/free AandBtext, AnotBtext, BnotAtext
	PK_List2textWave(BigList, "TextWaveA")
	gen_CompareTextWaves(TextWaveA, TextWaveB, AandBtext, AnotBtext, BnotAtext)
	if (numpnts(AandBtext)>0)
		HR_butt_ViewFamilyWaveTable("")
		string Fam = ReplaceString("familyWave_", gen_FindStrInTextWavesList(AandBtext[0], Flist, dfStr="root:HR"), "")
		string dups = sq_textWave2List(AandBtext)
		DoAlert 1, "The HR ions "+dups[0,50]+" are already explicitly family of "+Fam+". Select yes to remove these ions for this family and proceed."
		if (V_flag ==1)
			NewFamMemList = gen_removeListFromList(dups, NewFamMemList)
		else
			abort
		endif
	endif

	return NewFamMemList

End


Function pk_putMassValuesToWave(Twave, mwave)
wave/t Twave
wave mWave

	variable idex, num = numpnts(Twave)
	redimension/n=(num) mWave
	for(idex=0;idex<num;idex+=1)
		mWave[idex] = PK_FindMassFromFormula(Twave[idex])
	endfor

End

Function pk_butt_verifyFamilDisjoint(ba) : ButtonControl
	STRUCT WMButtonAction &ba

	switch( ba.eventCode )
		case 2: // mouse up
			string flist = gen_GetWaveListInDF("root:HR", "familyWave_*")
			string BigList = gen_CombineTextWaves2List(Flist, dfStr="root:HR")
			make/n=(itemsInLIst(BigList))/t/free TextWaveA = stringfromList(p,BigList)
#if(IgorVersion()>7)
	FindDuplicates/INDX=indexWave TextWaveA
#else
	wave indexWave = gen_findDuplicatesT(TextWaveA, "myindex")
#endif
			if (numpnts(indexWave)>0)
				HR_butt_ViewFamilyWaveTable("")
				Edit indexWave, TextWaveA
				Abort "// There were "+num2istr(numpnts(indexWave))+"duplicates." 
			else
				DoAlert 0, "No duplicates were found."
			endif
			killwaves/z indexWave, TextWaveA
			break
		case -1: // control being killed
			break
	endswitch

	return 0
End


Function pk_butt_fitFamily(ctrlName) : ButtonControl
	String ctrlName

	variable fitFlag = stringMatch("Fami_butt_Fit", CtrlName)
	string flist = gen_GetWaveListInDF("root:HR", "familyWave_*")
	flist = ReplaceString("familyWave_", flist, "")
	ControlInfo Fami_popup_viewFamilyOnly
	if (itemsInLIst(flist)==0)
		abort "You must first define at least one family, then select it from the popup menu."
	elseif(stringMatch("Get List", S_Value) )
		abort "You must a valid family from the popup menu."
	elseif(WhichListItem(S_Value, flist)<0)
		abort "This family is no longer valid.  Please reselect."
	else
		wave/t fam = $"root:HR:familyWave_"+S_Value
		HR_change2FitHRIon(fam,FitFlag)
	endif			
	HR_butt_MakeExactMassWaves("")
	return 0
End
