#pragma TextEncoding = "Windows-1252"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.


Function/wave HP_UpdateDataSet_todo()

	// first make sure todo is legit
	ControlInfo/W=HR_PToFDVaGraph ams_todolist_pop
	wave/z todo =$"root:"+S_Value
	if (!WaveExists(todo) || numpnts(todo)==0)  // bad todo
		abort "Please reselect the todo wave"
	endif
	sq_create_todo("allPToF and "+S_Value,"myTempTodo")
	wave todo = root:myTempTodo
	if (numpnts(todo)==0)  // bad todo
		killwaves/z root:myTempTodo
		abort "Please reselect the todo wave"
	endif
	
	// screen for ePToF
	sq_checkPToFparamsSameTodo(todo)					 // is ePToF
	if (sq_TodoHasPToF(todo, PToFFlag=0) )
		killwaves/z root:myTempTodo
		abort "Please reselect the todo wave"
	endif
	
	return todo
End

Function/wave HP_UpdateDataSet_DVa(todo)
wave todo

	variable runPos = sq_getRunPos(todo[0])
	make/o/n=10 root:HR_panel:DVa_wave/wave=DVa_wave 
	sq_GetPToFParams(DVa_wave, runPos)
	
	//update graph
	HP_UpdateGraph(DVa_wave)
	return DVa_wave

End


Function/c HP_UpdateDataSet_ss(DVa_wave)
wave DVa_wave

	// make sure start and stop are legit
	ControlInfo/W=HR_PToFDVaGraph setvar_StopBin
	variable stopBin = V_Value
	if (stopBin>= DVa_wave[%numPToFBins])
		setVariable setvar_StopBin, value= _NUM:(DVa_wave[%numPToFBins]-1), win = HR_PToFDVaGraph
		stopBin=DVa_wave[%numPToFBins]-1
	endif

	ControlInfo/W=HR_PToFDVaGraph setvar_StartBin
	variable startBin = V_Value
	if (startBin< 0)
		setVariable setvar_StartBin, value= _NUM:0, win = HR_PToFDVaGraph
	endif

	wave ptof_OrigdVaSize = root:HR_panel:ptof_OrigdVaSize

	TitleBox titleStartBin_nm, Win=HR_PToFDVaGraph, title = num2str(round(ptof_OrigdVaSize[startBin]))+"nm"
	TitleBox titleStopBin_nm, Win=HR_PToFDVaGraph, title = num2str(round(ptof_OrigdVaSize[stopBin]))+"nm"

	return cmplx(startBin, stopBin )
End

Function HP_UpdateDataSet_Name(DVa_wave, ss, nameFlag)
wave DVa_wave
variable/c ss
variable nameFlag

	variable startBin = real(ss)
	variable stopBin = imag(ss)

	// deal with single or matrix, name of data set
	ControlInfo/W=HR_PToFDVaGraph check_single
	variable singleFlag = V_Value

	ControlInfo/W=HR_PToFDVaGraph setvar_NumDatasets
	variable TotNewBins = V_Value

	string nameStr
	if (singleFlag)
		nameStr="b"+num2istr(startBin)+"x"+ num2istr(stopBin)
		TotNewBins=1
	else
		nameStr ="M"+num2istr(startBin)+"y"+ num2istr(stopBin)
		if (TotNewBins<=1)
			abort "For matricies, the number of new bins must be > 1"
		endif
	endif
	if (nameFlag)
		SetVariable PToF_toDoName Value=_STR:nameStr, win=HR_PToFDVaGraph
	endif
	
	Return TotNewBins
	
End


// deal with plotting
Function/wave HP_UpdateDataSet_Gr(DVa_wave, ss, TotNewBins)
wave DVa_wave
variable/c ss
variable TotNewBins

	make/free/n=10 HRPToFInfo
	gen_SetDimLabels(HRPToFInfo, 0, "RowPos;startBin;stopBin;MatrixFlag;IsSub;SubRowA;SubRowB;")
	HRPToFInfo[%MatrixFlag]=TotNewBins
	HRPToFInfo[%startBin] = real(ss)
	HRPToFInfo[%stopBin] = imag(ss)
	wave/wave x = HR_MakeHRPToFMxXaxis(HRPToFInfo, 0, "root:HR_panel:")
	gen_DrawVertLines( x[%tEdges], "HR_PToFDVaGraph")

	return x
End


Function HP_UpdateGraph(DVa_wave)
wave DVa_wave

	wave ptof_OrigdVaTime = root:HR_panel:ptof_OrigdVaTime
	wave ptof_OrigdVaSize = root:HR_panel:ptof_OrigdVaSize	
	nvar lc = root:panel:cor3_chamber	
	Redimension/n=(DVa_wave[%NumPToFBins]) ptof_OrigdVaSize, ptof_OrigdVaTime
	ptof_OrigdVaTime = DVa_wave[%t0] + p*DVa_wave[%step]
	ptof_OrigdVaSize = sq_ptof2dva(lc,DVa_wave[%vl],DVa_wave[%vg],DVa_wave[%b],DVa_wave[%dx],ptof_OrigdVaTime[p])
End



Function HP_DCgr_setToOld(ctrlName) : ButtonControl
	String ctrlName
	
	wave/z DCregion1Start = root:diagnostics:DCregion1Start
	wave/z DCregion1Stop = root:diagnostics:DCregion1Stop 
	wave/z DCregion2Start = root:diagnostics:DCregion2Start
	wave/z DCregion2Stop = root:diagnostics:DCregion2Stop
	wave/z/t DCregion1Only =root:diagnostics:DCregion1Only
	wave/z/t DCregion2Only =root:diagnostics:DCregion2Only

	nvar/z cor3_dcMarker1 = root:panel:cor3_dcMarker1
	nvar/z cor3_dcMarker2 =root:panel:cor3_dcMarker2
	nvar/z cor3_dcMarker3 =root:panel:cor3_dcMarker3
	nvar/z cor3_dcMarker4 =root:panel:cor3_dcMarker4
	svar/z cor3_region1channels = root:panel:cor3_region1channels
	svar/z cor3_region2channels = root:panel:cor3_region2channels
	nvar PToF_DCgr_runNumber = root:panel:PToF_DCgr_runNumber
	nvar ptof_dcUseBinNumUnits = root:panel:ptof_dcUseBinNumUnits
	nvar ptof_dcRegion1Allnot2 = root:panel:ptof_dcRegion1Allnot2

	variable runPos = sq_getRunPos(PToF_DCgr_runNumber)

	if (!WaveExists(DCregion1Start) || runPos<0)  // presume if one doesn't exist none do
		return 0
	endif

	if (ptof_dcUseBinNumUnits)
		if (numtype(DCregion1Start[runPos])==0)
			cor3_dcMarker1 = DCregion1Start[runPos]
			cor3_dcMarker2 = DCregion1Stop[runPos]
			cor3_dcMarker3 = DCregion2Start[runPos]
			cor3_dcMarker4 = DCregion2Stop[runPos]
			cor3_region1channels=DCregion1Only[runPos]
			cor3_region2channels=DCregion2Only[runPos]
		endif
	else
		if (numtype(DCregion1Start[runPos])==0)
			make/free DVa_wave
			sq_GetPToFParams(DVa_wave, runPos)	
			make/free/n=(DVa_wave[%numPToFBins]) ptof_BinTime_temp = 1e6*(DVa_wave[%t0]+ p*DVa_wave[%step])
			cor3_dcMarker1 = ceil(ptof_BinTime_temp[DCregion1Start[runPos]])
			cor3_dcMarker2 = floor(ptof_BinTime_temp[DCregion1Stop[runPos]])
			cor3_dcMarker3 = ceil(ptof_BinTime_temp[DCregion2Start[runPos]])
			cor3_dcMarker4 =floor(ptof_BinTime_temp[DCregion2Stop[runPos]])
			cor3_region1channels=DCregion1Only[runPos]
			cor3_region2channels=DCregion2Only[runPos]
		endif
	endif

	string str = DCregion1Only[runPos] 
	ptof_dcRegion1Allnot2 = stringmatch(str[0,2], "all")

End


// at this point all the sanity checks should have been done.
Function/s HR_calc_PTOFImage(waveNameSuffix, spectraType, specTypeInitial, paramStrPartial,HRPToFMxXaxis) // t_PToFCenters, dEdges, [deltaLogDiamCenters_op])
string waveNameSuffix, spectraType, specTypeInitial, paramStrPartial
wave/wave HRPToFMxXaxis  // t_PToFCenters, deltaLogDiamCenters_op, dEdges

	svar HRResults_ionList=root:HR_panel:HRResults_ionList
	svar sq_toDoWvNm=root:panel:sq_toDoWvNm
	nvar HR_checkConvertTougm3 = root:HR_panel:HR_checkConvertTougm3
	nvar tof1_norm=root:panel:tof1_norm
	nvar tof_stats=root:panel:tof_stats
	nvar tof1_datatype=root:panel:tof1_datatype
	nvar HRResults_graphOutputType = root:HR_panel:HRResults_graphOutputType
	nvar HR_checkConvertTougm3=root:HR_panel:HR_checkConvertTougm3
	wave/z todo=$(sq_toDoWvNm)

	variable idex,jdex,datatype,logop,ndex,baseval, runPos
	variable nTodo, pTodo, startrun, lowcut, noMSRunsFlag=0	, hiCut  //1.59D//1.51N
	string dummyStr ="", paramstr="", deststr="",speclist,prefix="",suffix="",dataStr,SpecNormStr="", nonSpecNormStr=""
	string d_base="", t_base="", legendStr="", str1, str2, mywinName, statsList="", nList="" 
	string MSWavList="", PToFAreaList="",nonSpecParamStr="",	SpecParamStr="", nonHRSpec,nonHRSpecDestList,HRSpecDestList,HRSpec,destList,returnList

	variable pos, hasPToF, hasEPToF, num,numSpec

// Get result waves name prefix
	if(HR_checkConvertTougm3==1)
		prefix="ug_"
	else
		prefix="sig_"
	endif
	if(tof1_datatype==1)		// ToF time or dXdlogDa vs logDa, NOT PToF
		logop=1
		prefix+="log_"
	endif

	if(strlen(d_base)>0)
		suffix+="_t"
	endif

	paramStrPartial+= "product_Type:5;"  // 5 for image, 6 for avg mass spec
	if(tof1_datatype==1)
		paramStrPartial+="dlog_op:1;t_PToFCenters:"+GetWavesDataFolder(HRPToFMxXaxis[%tCenters],2)+";"
	endif
	paramstr="";nonSpecParamStr=""
	SpecParamStr=""; nonHRSpecDestList="";HRSpecDestList=""
	returnList=""

//	for families
	nonHRSpec = HR_CheckListForHRSpecies(HRResults_ionList, 3)		// get list for HR masses and families, not for individual spectra
	if (strlen(nonHRSpec)>0)
	 	HR_getParamStr(nonSpecParamStr,nonHRSpec, 0, 0)		//1.06E
		specList=StringByKey("specList", nonSpecParamStr) 		// slightly confusing notation. HR ions are 'species' in this context 	
		sq_dataDestStr(nonHRSpecDestList,prefix,"im_"+waveNameSuffix+suffix,nonHRSpec,0)
		nonSpecParamStr+="specList:"+specList + ";"
		nonSpecParamStr+="destList:"+nonHRSpecDestList + ";"
		nonSpecParamStr+="HRSpec_flag:0;"
		returnList=nonHRSpecDestList
		squirrel_fetch(todo,PK_MS_concentration, nonSpecParamStr+paramStrPartial, spectraType)
	endif
 	
	// for HRspecies
	HRSpec = HR_CheckListForHRSpecies(HRResults_ionList, 4)		// get list for HR masses and families, not for individual spectra
	if (strlen(HRSpec)>0)
	 	HR_getParamStr(SpecParamStr,HRSpec, 1, 0)			//1.11G bug, we want to set the MS flag to 1 not zero.	//1.06E
		specList = StringByKey("specList", SpecParamStr) 	 	
		sq_dataDestStr(HRSpecDestList,prefix,"im_"+waveNameSuffix+suffix,HRSpec,0)
		SpecParamStr += "HRSpec_flag:1;"
		SpecParamStr += "specList:"+specList + ";"
		SpecParamStr += "destList:"+HRSpecDestList+";"		
		returnList+=HRSpecDestList
		squirrel_fetch(todo,PK_MS_concentration, SpecParamStr+paramStrPartial, spectraType)
	endif

	if (strlen(nonHRSpec)==0 && strlen(HRSpec)==0 )
		abort "You must select one or more HR species.  Aborting from HR_calc_PTOFImage"
	endif

	if (tof1_norm)	  // is size Dist or image	// section significantly redone in 1.51N
		wave MStodo = sq_getMSWaveForPToFNorm(todo, tof1_norm, noMSRunsFlag)			//1.22A
		variable numHRMS = PK_WavesForHRResultsDataSet("HROMinusC")
		paramStrPartial=replacestringbykey("timeweight_op",paramStrPartial,"3")		//1.51M  timeweight_op 3 is for open + closed time	
		paramStrPartial=replacestringbykey("product_type",paramStrPartial,"1")		// product type 0 is a single value	// 1.51 Change.		// product type 1 is a regular time series  
		paramStrPartial=replacestringbykey("spectraType",paramStrPartial,"HROMinusC") 
		paramStrPartial=replacestringbykey("PToFFlag",paramStrPartial,"0")		  
		paramStrPartial=replacestringbykey("dlog_op",paramStrPartial,"0")	  
		paramStrPartial+="min_cl:0;max_cl:"+num2str(numHRMS-1)+";"
		if (noMSRunsFlag)
			make/FREE /o/n=(numpnts(root:index:rn_series)) PToFtodoMask_temp
			sq_makeMaskFromTodofindRun(PToFtodoMask_temp,todo)					
			PToFtodoMask_temp = numtype(PToFtodoMask_temp[p])==0 ? PToFtodoMask_temp[p] : 0 			
		endif

		if (strlen(nonHRSpec)>0)
			sq_dataDeststr(nonSpecNormStr,"MS4PToFNorm_","",nonHRSpec,1)			//1.51I    waves will be killed at the end
			nonSpecParamStr=replacestringbykey("destlist",nonSpecParamStr,nonSpecNormStr)
//			print nonSpecParamStr
//			print paramStrPartial
			squirrel_fetch(MStodo,PK_MS_concentration,nonSpecParamStr+paramStrPartial,"HROminusCStick")
			specList = StringByKey("specList", nonSpecParamStr) 	 	
		endif
		if (strlen(HRSpec)>0)
			sq_dataDeststr(SpecNormStr,"MS4PToFNorm_","",HRSpec,1)			//1.51I    waves will be killed at the end
			SpecParamStr=replacestringbykey("destlist",SpecParamStr,SpecNormStr)
//			print SpecParamStr+paramStrPartial
			squirrel_fetch(MStodo,PK_MS_concentration,SpecParamStr+paramStrPartial,"HROminusCStick")
			specList += StringByKey("specList", SpecParamStr) 
		endif				

		sq_PTOFnormTraces(returnList, nonSpecNormStr+SpecNormStr, nonHRSpec+HRSpec, noMSRunsFlag, t_base, d_base, waveNameSuffix, 5,HRPToFMxXaxis[%deltalogdEdges], sq_toDoWvNm, MSWavList, PToFAreaList)
		nList= "MSWavList:"+MSWavList+";PToFAreaList:"+PToFAreaList+";"
	endif

	if (tof_stats && tof1_datatype==1)// Step 7 do PToF stats		 we do this AFTER normalization so that stats will reflect what the user sees
		statsList=""
		for(idex=0;idex<itemsinlist(returnList,"/");idex+=1)		// for each species
			wave destwav=$stringfromlist(idex,returnList,"/")		// Size distrib or image of one species 
			// Step 4D. Find PToF stats					
			statsList += sq_calc_PTOFimage_stats(destwav, HRPToFMxXaxis[%dEdges], HRPToFMxXaxis[%logdEdges], HRPToFMxXaxis[%deltalogdEdges], sq_toDoWvNm, stringfromlist(idex,speclist,"/"), updateFlag=(HRResults_graphOutputType==4) ) +"/"   //1.60T	  HRResults_graphOutputType
		endfor		// for each species
		nList+="statsList:"+statsList
	endif

	returnList =RemoveFromList(";", returnList, "/")	
	return "Wave2PlotList:"+returnList+";"+nList

End


Function HP_SetVarProc(ctrlName,varNum,varStr,varName) : SetVariableControl
	String ctrlName
	Variable varNum
	String varStr
	String varName

	wave todo = HP_UpdateDataSet_todo()
	wave DVa_wave = HP_UpdateDataSet_DVa(todo)
	variable/c ss = HP_UpdateDataSet_ss(DVa_wave)
	variable TotNewBins = HP_UpdateDataSet_Name(DVa_wave, ss, 1)
	HP_UpdateDataSet_Gr(DVa_wave, ss, TotNewBins)

End


//  when we divide up n number of PToF bins in m number of new bins
// puts values into integer start and stop waves
Function HP_GetBinGroupings(TotNewBins, minBin, maxBin, startWave, stopWave)
variable TotNewBins, minBin, maxBin
wave/i startWave
wave/i stopWave
		
	redimension/n=(TotNewBins) startWave,stopWave
	variable idex, currentNumBins, extra, delta, thisDelta
	extra = mod(maxBin+1-minBin,TotNewBins)  // extra will be a value ranging from 0 to TotNewBins-1 big
	delta = floor( (maxBin+1 - (minBin))/TotNewBins)
	
	if (delta<1)
		abort "The bin ranges are not possible.  Aborting from PToF_GetBinGroupings"
	endif
		
	startWave[0] = minBin
	for(idex=0;idex<TotNewBins;idex+=1)
		thisDelta  = delta + ((TotNewBins-idex)<=extra)  
		stopWave[idex] = startWave[idex]+thisDelta-1
		if (idex+1 < TotNewBins)
			startWave[idex+1] = stopWave[idex] +1
		endif
	endfor
end


Function HP_butt_PToFDataSet(ctrlName) : ButtonControl
	String ctrlName

	ControlInfo/W=HR_Analysis_Panel HRResults_pop_dataSet
	if (stringMatch(S_Value, "Initialize") || stringMatch(S_Value, "Get List"))
		abort "Please select the data type from the drop down menu."
	else
		string spectraType=S_Value
	endif

	if (!stringmatch(spectraType[0,3],"PTOF" ))
		abort "Please select a PToF data set"
	endif
	
	make/free/n=9 HRPToFInfo
	pk_returnHRPToFInfo(spectraType, HRPToFInfo) 
	if (HRPToFInfo[%matrixFlag]==0)
		abort "The selected data set is not a matrix."
	endif

	string todoStr = Note(HRPToFInfo)
	wave/z todo=$"root:"+todoStr	
	if (!WaveExists(todo))
		DoAlert 0, "The todo wave used to create this data set, "+todoStr+" no longer exists.  Try using the currently selected todo (yes) or abort (no)?"
		if (V_flag==2)
			abort 
		endif
		svar sq_toDoWvNm=root:panel:sq_toDoWvNm
		todoStr=sq_toDoWvNm
		wave/z todo=$"root:"+todoStr		
	endif

	variable runpos = sq_GetRunPos(todo[0])
	
	string rootStr = ReplaceString("PTOF", ReplaceString("Stick", spectraType, ""), "")

	wave/wave HRPToFMxXaxis = HR_MakeHRPToFMxXaxis(HRPToFInfo, runPos, "root:PToF:"+rootStr+"_")

	string tablename = "TPToF_"+rootStr
	HP_DataSetTable(tablename, HRPToFMxXaxis)
End


Function HP_DataSetTable(tablename, HRPToFMxXaxis)
string tablename
wave/wave HRPToFMxXaxis
	
	DoWindow/F $tablename
	if (!V_flag)
//		edit/N=$tablename HRPToFMxXaxis[%tEdges], HRPToFMxXaxis[%dEdges], HRPToFMxXaxis[%logdEdges] as tablename
//		AppendtoTable/W=$tablename HRPToFMxXaxis[%tCenters], HRPToFMxXaxis[%dCenters], HRPToFMxXaxis[%startBins],HRPToFMxXaxis[%stopBins]
		edit/N=$tablename as tablename
		variable idex
		for(idex=0;idex<numpnts(HRPToFMxXaxis);idex+=1)
			AppendtoTable/W=$tablename HRPToFMxXaxis[idex]
		endfor
	endif	
End


// from the PToF data set panel/graph, show potential new PToF bins and edges
Function HP_butt_PToFDataSetTable(ctrlName) : ButtonControl
	String ctrlName
	
	wave todo = HP_UpdateDataSet_todo()
	wave DVa_wave = HP_UpdateDataSet_DVa(todo)
	variable/c ss = HP_UpdateDataSet_ss(DVa_wave)
	variable TotNewBins = HP_UpdateDataSet_Name(DVa_wave, ss, 1)
	wave/wave HRPToFMxXaxis = HP_UpdateDataSet_Gr(DVa_wave, ss, TotNewBins)
	HP_DataSetTable("PToFDataSetTable", HRPToFMxXaxis)
End


Function/wave HR_MakeHRPToFMxXaxis(HRPToFInfo, runPos, dfStr)
wave HRPToFInfo
variable runPos
string dfStr
	
	nvar tof0_gppp=root:panel:tof0_gppp
	
	variable TotNewBins = max(1,HRPToFInfo[%matrixFlag]) // allow use for both matrix and single bin
	variable minBin = HRPToFInfo[%StartBin]
	variable maxBin = HRPToFInfo[%StopBin]
	
	make/i/o/n=(TotNewBins) $dfStr+"BinStartPt"/wave=startWave, $dfStr+"BinStopPt"/wave=stopWave
	HP_GetBinGroupings(TotNewBins, minBin, maxBin, startWave, stopWave)
	make/i/free/n=(TotNewBins) binDelta = stopWave - startWave+1

	make/o/n=(TotNewBins+1) $dfStr+"dEdges"/wave=dEdges, $dfStr+"logdEdges"/wave=logdEdges, $dfStr+"tEdges"/wave=tEdges	//1.51  defines EDGES of PToF regions, not middle
	make/o/n=(TotNewBins)  $dfStr+"dCenters"/wave=dCenters, $dfStr+"tCenters"/wave=tCenters, $dfStr+"deltalogdEdges"/wave=deltalogdEdges

	make/o/n=8/free/wave PToFWaves
	gen_SetDimLabels(PToFWaves, 0, "tEdges;dEdges;tCenters;dCenters;logdEdges;deltalogdEdges;startBins;stopBins")

	make/o/n=6/Free DVa_wave 
	sq_GetPToFParams(DVa_wave, runPos)

	tCenters[0] = DVa_wave[%t0]+ HRPToFInfo[%StartBin]*DVa_wave[%step] + 0.5*binDelta[0]*DVa_wave[%step]
	if (TotNewBins>1)
		tCenters[1,] = tCenters[p-1] + binDelta[p]*DVa_wave[%step]
	endif
	dCenters=sq_ptof2dva(DVa_wave[%chamberLen],DVa_wave[%vl],DVa_wave[%vg],DVa_wave[%b],DVa_wave[%dx],tCenters[p]) //  1.53F

	tEdges[0]=DVa_wave[%t0]+HRPToFInfo[%StartBin]*DVa_wave[%step] - 0.5*DVa_wave[%step]
	tEdges[1,]=tEdges[p-1]+binDelta[p-1]*DVa_wave[%step]
	dEdges=sq_ptof2dva(DVa_wave[%chamberLen],DVa_wave[%vl],DVa_wave[%vg],DVa_wave[%b],DVa_wave[%dx],tEdges[p]) //  1.53F
	
	wavestats/q/m=1 logdEdges
	logdEdges=log(dEdges[p])
	variable lowcut=max(v_min,log(tof0_gppp)) // Enforce GP/PP boundary
	logdEdges=limit(logdEdges[p], 0, inf )  // max(min(logdEdges[p],v_max),lowcut) // Protect algorithm from infs and -infs.
	deltalogdEdges = logdEdges[p+1] - logdEdges[p] 
	
	PToFWaves[%tEdges] = tEdges
	PToFWaves[%dEdges] =  dEdges
	PToFWaves[%tCenters] = tCenters
	PToFWaves[%dCenters] = dCenters
	PToFWaves[%logdEdges] = logdEdges
	PToFWaves[%deltalogdEdges] = deltalogdEdges
	PToFWaves[%startBins] = startWave
	PToFWaves[%stopBins] = stopWave
		
	return PToFWaves
End


Function HP_ck_PToFSingleOrMany(ctrlName,checked) : CheckBoxControl  //1.60E
	String ctrlName
	Variable checked

	wave todo = HP_UpdateDataSet_todo()
	wave DVa_wave = HP_UpdateDataSet_DVa(todo)
	//variable/c ss = PToF_UpdateDataSet_ss(DVa_wave)
	//PToF_UpdateDataSet_Name(DVa_wave, ss)

	variable singleFlag = WhichlistItem(ctrlName, "check_single;check_many;check_matrix") 
	CheckBox check_single value= singleFlag==0	, win=HR_PToFDVaGraph
	CheckBox check_matrix value= singleFlag==2, win=HR_PToFDVaGraph
	SetVariable PToF_toDoName value= _STR:selectString((singleFlag-1), "bAxB", "bAxB", "MAxB")	, win=HR_PToFDVaGraph	  // 1.21G	
	SetVariable setvar_NumDatasets disable = (singleFlag==0)*2 , win=HR_PToFDVaGraph
End


Function HP_PopMenuProc(ctrlName,popNum,popStr) : PopupMenuControl
	String ctrlName
	Variable popNum
	String popStr
	
	sq_pop_toDoList(ctrlName,popNum,popStr)
	HP_UpdateDataSet_todo()
End


Function HP_ButtSetDC(ctrlName) : ButtonControl
	String ctrlName

	wave todo = HP_UpdateDataSet_todo()
	wave DVa_wave = HP_UpdateDataSet_DVa(todo)
	variable runPos = sq_GetRunPos(todo[0])
	sq_dcMarkersExamine(runPos)

	HP_ck_PToFSingleOrMany("check_single",1)
	Checkbox check_single value =1, win=HR_PToFDVaGraph
	
	HP_DCgr_setToOld("")   // set variables in DC region to previously preprocessed values
	
	wave ptof_dcMarkersPtWave = root:panel:ptof_dcMarkersPtWave
	variable DC1Flag = stringmatch(ctrlName[strlen(ctrlName)-1], "1")
	if (DC1Flag)
		SetVariable setvar_StartBin, win=HR_PToFDVaGraph, value =_NUM:(ptof_dcMarkersPtWave[0])
		SetVariable setvar_StopBin, win=HR_PToFDVaGraph, value =_NUM:(ptof_dcMarkersPtWave[1])
	else
		SetVariable setvar_StartBin, win=HR_PToFDVaGraph, value =_NUM:(ptof_dcMarkersPtWave[2])
		SetVariable setvar_StopBin, win=HR_PToFDVaGraph, value =_NUM:(ptof_dcMarkersPtWave[3])
	endif
	
	variable/c ss = HP_UpdateDataSet_ss(DVa_wave)
	variable TotNewBins = HP_UpdateDataSet_Name(DVa_wave, ss, 1)
	HP_UpdateDataSet_Gr(DVa_wave, ss, TotNewBins)
	if (DC1Flag)
		SetVariable PToF_toDoName  value= _STR:"dc1", win=HR_PToFDVaGraph
	else
		SetVariable PToF_toDoName  value= _STR:"dc2", win=HR_PToFDVaGraph
	endif

	killwaves/z root:myTempTodo

End


Function HP_butt_CreateDataSet(ctrlName) : ButtonControl
	String ctrlName

	wave/t PToFDataSetNames= root:PToF:PToFDataSetNames
	wave/t PToFDataSetTodo= root:PToF:PToFDataSetTodo
	wave/i PToFDataSetStartPt= root:PToF:PToFDataSetStartPt
	wave/i PToFDataSetStopPt= root:PToF:PToFDataSetStopPt
	wave/i PToFDataSetMaxmz= root:PToF:PToFDataSetMaxmz
	wave/i PToFDataSetMatrixFlag= root:PToF:PToFDataSetMatrixFlag
	wave/i PToFTodoFit= root:PToF:PToFTodoFit		// selection wave for HR panel

	wave numPtsRawSpectra = root:diagnostics:numPtsRawSpectra
	wave mzIntercept  = root:diagnostics:mzInt
	wave mzSlope  = root:diagnostics:mzSlope
	wave mzPower  = root:diagnostics:mzPower
	wave mFinish = root:diagnostics:mFinish
	svar sq_toDoWvNm = root:panel:sq_toDoWvNm

	string paramPartial, nameStr, maxRawPtStr, paramStr=""
	variable runPos, endMzPt, maxMz, DataSetNamePt, minBin, maxBin, numRaw,TotNewBins, newFlag, RawPToFPos

	// sanity checks
	wave todo = HP_UpdateDataSet_todo()
	wave DVa_wave = HP_UpdateDataSet_DVa(todo)
	variable/c ss = HP_UpdateDataSet_ss(DVa_wave)
	TotNewBins = HP_UpdateDataSet_Name(DVa_wave, ss, 0)
	HP_UpdateDataSet_Gr(DVa_wave, ss, TotNewBins)
	minBin = real(ss)
	maxBin = imag(ss)
	
	wave/z RawPToFtodo = sq_makeRawPToFtodo()
	if (!WaveExists(RawPToFtodo))
		Abort "Raw PToF spectra has not yet been indexed. Look for *_p files in the list of indexed DAQ and intermediate files."
	endif
	
	ControlInfo/w=HR_PToFDVAGraph ams_todolist_pop 		//1.22A
	if (!stringmatch(sq_toDoWvNm, S_Value) )
		abort "Please reselect the todo wave."
	endif
	
	sq_create_todo("RawPToF and "+sq_toDoWvNm,"todoPToFSubset")
	wave todo = root:todoPToFSubset
	if (numpnts(todo)==0 )
		killwaves/z todoPToFSubset
		abort "This todo wave has zero many runs with raw PToF spectra."
	endif

	runPos = sq_FindRun(root:index:rn_series, todo[0])
	ControlInfo/w=HR_PToFDVAGraph setvar_maxMz

	wave UnitMass = root:HR_Sticks:UnitMass   //1.22A
	if (WaveMax(UnitMass)>mFinish[runPos])  // our max mz is too small.
		doAlert 0, "The ending m/z value for this PToF spectra is "+num2istr(mFinish[runPos])+", smaller than the maximum HR ion you last chose to fit "+num2istr(WaveMax(UnitMass))+". The code will set the max m/z to the largest allowable."
		maxMz = mFinish[runPos]
	else  // majority of cases.. WaveMax(UnitMass)<= mFinish[runPos]
		if (V_value<WaveMax(UnitMass))  // our max mz is too small.
			doAlert 0, "The ending m/z value you chose is "+num2istr(V_value)+", smaller than the maximum HR ion you last chose to fit "+num2istr(WaveMax(UnitMass))+". The code will set the max m/z to the largest allowable."
			maxMz = WaveMax(UnitMass)// so now WaveMax(UnitMass)<=V_Value and V_Value<= mFinish[runPos]
		else  // WaveMax(UnitMass)<=V_Value AND WaveMax(UnitMass)<=mFinish[runPos]
			maxMz=V_value
		endif
	endif	

	SetVariable setvar_maxMz value=_NUM:(maxMz) , win=HR_PToFDVAGraph   //1.22A
	numRaw=numPtsRawSpectra[runPos]
	
	ControlInfo PToF_toDoName
	nameStr = CleanupName(ReplaceString("Stick",ReplaceString("PToF",ReplaceString("_", S_Value, ""), ""), ""),0)	//1.19E
	if (!stringmatch(S_Value, nameStr) ||  strlen(S_Value)> 20 ||  strlen(S_Value)==0 )
		SetVariable PToF_toDoName value= _STR:nameStr  //
		DoAlert 1,  "Your suggested name for a PToF data set has been changed to "+nameStr+" To proceed with creating a PToF data set, press yes; to exit press no."
		if (V_flag==2)
			abort
		endif	
	endif
	if (stringMatch("bAxB", nameStr) || stringMatch("MAxB", nameStr) || strlen(nameStr)==0)
		abort "Please create PToF data sets without using the names bAxB or MAxB"
	endif
		
	newFlag =HP_checkPToFExistence(nameStr, minBin, maxBin, maxMz, TotNewBins) 
	switch (newFlag)
		case 5:
			DoAlert 1, "You have already created a PToF data set of the name "+nameStr+" and with the same start/stop parameters. Are you sure you wish to continue?"
			if (V_flag==2)
				abort
			endif		
		break
		case 1:
		case 2:
		case 3:
		case 4:
			abort "You have already created a PToF data set of the name "+nameStr+" and with the same start/stop bin parameters. You may not overwrite it with different parameters. Please modify the name."
		break
		case 13:
			DoAlert 1, "It appears that you have a PToF data set of a different name, but with the same start/stop bin parameters. Are you sure you wish to continue?"
			if (V_flag==2)
				abort
			endif		
	endswitch
	
	// all checking is done, let's go!
	paramStr = "LessBL:1;"		//  +num2str(findLessBL)+";"	
	
 	make/o/n=(numRaw)/Free OneRunRawSpectraMz = ((p - mzIntercept[runPos])/mzSlope[runPos])^(1/(mzPower[runPos]))
	if ( mzIntercept[runPos]>0)
 		OneRunRawSpectraMz[0,ceil( mzIntercept[runPos])]=0		//1.14I		//1.55I  Tim O issue
	endif
	EndMzPt = round(BinarySearch(OneRunRawSpectraMz, maxMz+.5 ))		// .5 is rounding
	if (EndMzPt<0)			//1.19C
		EndMzPt = numRaw
	else
		EndMzPt += 100 - mod(EndMzPt, 100)  // round off in case of shifting mz
		EndMzPt = min(EndMzPt, numRaw)
	endif
	sprintf maxRawPtStr, "%d", endMzPt
	paramStr += "min_ly:0;max_ly:"+maxRawPtStr+";"
		
	// get to work creating PToF data sets
	paramPartial = "matrixFlag:"+num2str(TotNewBins>1)+";"
	paramPartial += "MinBin:"+num2istr(minBin)+";"
	paramPartial += "MaxBin:"+num2istr(maxBin)+";"
	paramPartial += "TotNewBins:"+num2istr(TotNewBins)+";"
	paramPartial += "NameStr:"+nameStr+";"
	
	sq_ams_stat_upd("Creating PTOF data sets for later HR fitting...")
	squirrel_fetch(todo,HP_SaveDataSet, paramStr+paramPartial,"PToF")
	sq_ams_stat_upd("Done")
					
	DataSetNamePt = sq_findStr(PToFDataSetNames,nameStr,1)
	if (DataSetNamePt==-1)		// a new data set
		DataSetNamePt=numpnts(PToFDataSetNames)		// 1.57J
		Insertpoints DataSetNamePt, 1, PToFDataSetTodo, 	PToFDataSetNames, PToFDataSetStartPt, PToFDataSetStopPt, PToFDataSetMaxMz, PToFDataSetMatrixFlag, PToFTodoFit	
	endif
	PToFDataSetTodo[DataSetNamePt]=sq_toDoWvNm
	PToFDataSetNames[DataSetNamePt]=nameStr
	PToFDataSetStartPt[DataSetNamePt]=minBin
	PToFDataSetStopPt[DataSetNamePt]=maxBin
	PToFDataSetMaxmz[DataSetNamePt]=maxMz
	PToFDataSetMatrixFlag[DataSetNamePt]=TotNewBins

	SaveExperiment
		
	killwaves/z root:todoPToFSubset

End


// originally this was made to work for raw or stick spectra, now only used for raw
Function HP_SaveDataSet(index_pos,paramstr,acorn,n_acorns)	
    wave index_pos	// point nos in rn_series to act on			
    string paramstr	
    variable acorn,n_acorns
	
	wave rawPToF=$stringbykey("acorn_0",paramstr)  		// runs x num ptof bins x mz
	string NameStr = StringByKey("NameStr",paramstr)
	
	wave/z mzSlope=root:mzFitting:mz_FitSlope
	wave/z mzPower=root:mzFitting:mz_FitPower
	wave/z mzInt=root:mzFitting:mz_FitIntercept
	if (!WaveExists(mzSlope))
		abort "You must first perform your m/z calibrations before this functionality is allowed. Aborting from PToF_SaveDataSet"	
	endif
	
	sq_ams_stat_upd("Generating grouped raw PToF spectra")  //1.22A	
	sq_ams_prog_upd(100*acorn/n_acorns)

	sq_Hz(index_pos,rawPToF)

	if (acorn == 0)
		variable TotNewBins = numberByKey("TotNewBins",paramstr)
		variable minBin = numberByKey("minBin",paramstr)
		variable maxBin = numberByKey("maxBin",paramstr)
		make/o/i/n=(TotNewBins) root:PToF:startPtWave/wave=startPtWave
		make/o/i/n=(TotNewBins) root:PToF:stopPtWave/wave=stopPtWave
		HP_GetBinGroupings(TotNewBins, minBin, maxBin, startPtWave, stopPtWave)
	else
		wave startPtWave = root:PToF:startPtWave
		wave stopPtWave = root:PToF:stopPtWave
	endif
	wave RawAvgPToF = HP_RebinPToF(rawPToF, startPtWave,stopPtWave , 1)
	
	squirrel_hdf_write(index_pos,RawAvgPToF,"PTOF"+NameStr)        // uses squirrel infrastructure to write to the intermediate file
	
//	if (LessBaselineFlag)
		duplicate/FREE /o RawAvgPToF rawAvgPToFBk
		// note that we do not bother with checking if we need to  use separate open/closed m/z fitting parameters
		bk_CreateBackgroundValues(index_pos, rawAvgPToFBk,  mzSlope, mzInt, mzPower, "MSP")
		RawAvgPToF-=rawAvgPToFBk
		//1.14M raw spectra
		squirrel_hdf_write(index_pos,RawAvgPToF,"PTOF"+NameStr+"_BL")        // uses squirrel infrastructure to write to the intermediate file
//	endif

	if (acorn == n_acorns-1)
		sq_ams_stat_upd("Done")  //1.22A	
		killwaves/z startPtWave,stopPtWave, M_SumPlanes 
	endif

End

Function HP_checkPToFExistence(nameStr, minCol, maxCol, maxMz, numNewBins)
string nameStr
variable minCol, maxCol, maxMz,numNewBins

	wave/t PToFDataSetNames= root:PToF:PToFDataSetNames
	wave/i PToFDataSetStartPt= root:PToF:PToFDataSetStartPt
	wave/i PToFDataSetStopPt= root:PToF:PToFDataSetStopPt
	wave/i PToFDataSetMaxmz= root:PToF:PToFDataSetMaxmz
	wave/i PToFDataSetMatrixFlag= root:PToF:PToFDataSetMatrixFlag

	variable newFlag=0
	FindValue/Txop=4/Text=nameStr PToFDataSetNames
	if (V_Value>=0)// does this data set name already exist?
		newFlag = 1
		newFlag += PToFDataSetStartPt[V_Value]==minCol
		newFlag += PToFDataSetStopPt[V_Value]==maxCol
		newFlag += PToFDataSetMaxmz[V_Value]==maxMz
		newFlag += numNewBins == 1 ? PToFDataSetMatrixFlag[V_Value]== 1 : PToFDataSetMatrixFlag[V_Value]==numNewBins
	else  // name doesn't exist, but are all the other parameters the same?
		FindValue/I=(round(minCol)) PToFDataSetStartPt
		newFlag=10
		if (V_Value>=0)// does this data set name already exist?
			newFlag += PToFDataSetStopPt[V_Value]==maxCol
			newFlag += PToFDataSetMaxmz[V_Value]==maxMz
			newFlag += numNewBins == 1 ? PToFDataSetMatrixFlag[V_Value]== 0 : PToFDataSetMatrixFlag[V_Value]==numNewBins
		endif
	endif

	return newFlag
	
End

	
//1.60E
function/wave HP_RebinPToF(PToF3D, startPtW, stopPtW, killFlag) // PToF3D = runs x PToF x mz
wave PToF3D, startPtW, stopPtW
variable killFlag
	
	make/free/i/n=3 dims = dimsize(PToF3D,p)

	variable idex, TotNewBins =numpnts(startPtw), numbins = stopPtw[0]-startPtw[0]+1

	MatrixOp/o/FREE rawPToFTranspose =  transposeVOl(PToF3D,1)  // output=w[p][r][q]// rawPToFTranspose = runs x mz x PToF  
  	make/free/o/n=(dims[0],dims[2],TotNewBins) RawAvgPToF	//will hold results         			RawAvgPToF = runs x mz x PToF 		
	make/free/o/n=(dims[0],dims[2],numbins) RawAvgPToFImage 	//will hold one new value  RawAvgPToFImage = runs x mz x PToF 

	for(idex=0;idex<TotNewBins;idex+=1)  // cannot use ImageTransform  averageImage because that requires at least 3 layers
		numbins =stopPtw[idex] - startPtw[idex]+1
		redimension/n=(dims[0],dims[2],numbins) RawAvgPToFImage
		Multithread RawAvgPToFImage =rawPToFTranspose[p][q][startPtw[idex]+r]
		ImageTransform SumPlanes RawAvgPToFImage   													
		wave M_SumPlanes																		///M_SumPlanes = runs x mz
		Multithread M_SumPlanes/=numbins
		ImageTransform/P=(idex)/D=M_SumPlanes setPlane RawAvgPToF
	endfor

	if (TotNewBins==1)
		return M_SumPlanes
	else
		MatrixOp/o/FREE FinalRebinned =  transposeVOl(RawAvgPToF,1)  // output=w[p][r][q]
		return FinalRebinned	
	endif
	
end



// 1.22A
Function HR_calcplot_PTOFMS(waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial, HRPToFMxXaxis)
string waveNameSuffix,myPlotName, spectraType, specTypeInitial, paramStrPartial
wave/wave HRPToFMxXaxis

	nvar tof1_datatype=root:panel:tof1_datatype
	nvar HRResults_graphOutputType=root:HR_panel:HRResults_graphOutputType
	nvar HR_checkAvgHRMS_UMR=root:HR_panel:HR_checkAvgHRMS_UMR

	variable idex, DvaAxis = tof1_datatype==1
	string tempStr = HR_calc_PTOFMS(waveNameSuffix, spectraType, specTypeInitial, paramStrPartial, HRPToFMxXaxis) //[%tCenters], deltaLogDiamCenters_op=HRPToFMxXaxis[%deltalogdEdges] ) 
	
	string destListnonHRSpec = stringFromList(0, tempStr, ";")
	string destListHRSpec = stringFromList(1, tempStr, ";")
	
	if (HR_checkAvgHRMS_UMR)
		wave xWave =root:HR_Sticks:amu_HR
		duplicate/o root:HR_Sticks:amu_HR $"root:amu_HR_"+waveNameSuffix/wave=xWave		
	endif
	
	if(HRResults_graphOutputType == 1)  // single
		if (itemsInList(destListnonHRSpec)>0)
			if (!HR_checkAvgHRMS_UMR)
				wave ExactMassWave_FitTodo = root:HR_Sticks:ExactMassWave_FitTodo
				duplicate/o ExactMassWave_FitTodo $"root:ExactMassWave_"+waveNameSuffix/wave=xWave		
				wave/t ExactMassText_FitTodo = root:HR_Sticks:ExactMassText_FitTodo
				duplicate/o/t ExactMassText_FitTodo $"root:ExactMassText_"+waveNameSuffix/wave=xWaveText		
				for(idex=0;idex<itemsInList(destListnonHRSpec, "/");idex+=1)
					wave AvgPToFMS=$stringFromList(idex, destListnonHRSpec, "/")
					edit xWave, xWaveText, AvgPToFMS 
				endfor	
			else
				for(idex=0;idex<itemsInList(destListnonHRSpec, "/");idex+=1)
					wave AvgPToFMS=$stringFromList(idex, destListnonHRSpec, "/")
					edit xWave, AvgPToFMS 
				endfor	
			endif
		endif
		
		if (itemsInList(destListnonHRSpec)>0)
			if (!HR_checkAvgHRMS_UMR)
				wave SpeciesMassWave = root:HR_frag:SpeciesMassWave
				duplicate/o SpeciesMassWave $"root:SpeciesMassWave_"+waveNameSuffix/wave=xWave		
				wave/t SpeciesMassText = root:HR_frag:SpeciesMassText
				duplicate/o/t SpeciesMassText $"root:SpeciesMassText"+waveNameSuffix/wave=xWaveText		
				for(idex=0;idex<itemsInList(destListHRSpec, "/");idex+=1)
					wave AvgPToFMS=$stringFromList(idex, destListHRSpec, "/")
					edit xWave, xWaveText, AvgPToFMS 
				endfor	
			endif
		else
			for(idex=0;idex<itemsInList(destListnonHRSpec, "/");idex+=1)
				wave AvgPToFMS=$stringFromList(idex, destListnonHRSpec, "/")
				edit xWave, AvgPToFMS 
			endfor	
		endif
	endif
	
End


// 1.22A
Function/s HR_calc_PTOFMS(waveNameSuffix, spectraType, specTypeInitial, paramStrPartial, HRPToFMxXaxis)
string waveNameSuffix, spectraType, specTypeInitial, paramStrPartial
wave/wave HRPToFMxXaxis

	svar HRResults_ionList=root:HR_panel:HRResults_ionList
	svar sq_toDoWvNm=root:panel:sq_toDoWvNm
	nvar tof1_datatype=root:panel:tof1_datatype
	nvar HRResults_graphOutputType = root:HR_panel:HRResults_graphOutputType
	nvar HR_checkConvertTougm3=root:HR_panel:HR_checkConvertTougm3
	nvar HR_checkAvgHRMS_UMR=root:HR_panel:HR_checkAvgHRMS_UMR
	wave/z todo=$(sq_toDoWvNm)

	variable idex,logop, datatype,baseval, runPos
	variable lowcut, noMSRunsFlag=0	, hiCut
	string deststr="",speclist,prefix="",suffix=""
	string d_base, t_base, legendStr="", statsList="", HRSpecDestList
	string nonSpecParamStr="",	SpecParamStr="", nonHRSpec,nonHRSpecDestList,HRSpec,destList,returnList=""

	variable numSpec

	wave rn_series = root:index:rn_series
	wave/z/i todo=$"root:"+sq_toDoWvNm

	sq_checkPToFparamsSameTodo(todo)
	
	// Check if todo wave has >0 PToF spectra.  We possibly reduce the selected todo wave to run that have PToF (todo = tempTodo)
	wave/z allPToF = root:allPToF	
	if (WaveExists(allPToF))
		sq_create_todo(sq_toDoWvNm+" and allPTOF","TempPToF")
		wave todo = root:TempPToF
		if (numpnts(todo)==0)
			killwaves/z root:tempTodo
			abort "There are no PToF runs in "+sq_toDoWvNm+".  Aborting from Pk_butt_ToFConc"
		endif
	endif
	
	runPos=sq_findrun(rn_series,todo[0])

	if(HR_checkConvertTougm3==1)
		prefix="ug_"
	else
		prefix="sig_"
	endif
	if(tof1_datatype==1)		// ToF time or dXdlogDa vs logDa, NOT PToF
		logop=1
		prefix+="log_"
	endif

	paramStrPartial+= "product_Type:6;" // 5 for image, 6 for avg mass spec
	if(tof1_datatype==1)
		paramStrPartial+="dlog_op:1;t_PToFCenters:"+GetWavesDataFolder(HRPToFMxXaxis[%tCenters],2)+";"  // t_PToFCenters
	endif
	nonSpecParamStr=""
	SpecParamStr=""
	nonHRSpecDestList="";HRSpecDestList=""
	returnList=""

//	for families
	nonHRSpec = HR_CheckListForHRSpecies(HRResults_ionList, 3)		// get list for HR masses and families, not for individual spectra
	if (strlen(nonHRSpec)>0)
	 	HR_getParamStr(nonSpecParamStr,nonHRSpec, 0, 0)		//1.06E
		specList=StringByKey("specList", nonSpecParamStr) 		// slightly confusing notation. HR ions are 'species' in this context 	
//		sq_dataDestStr(nonHRSpecDestList,prefix,"av_"+waveNameSuffix,nonHRSpec,0)
		nonHRSpecDestList ="PMSS" +SpecTypeInitial+"_"+waveNameSuffix+"_"+ReplaceString("/", specList, "/PMSS" +SpecTypeInitial+"_"+waveNameSuffix+"_")
		nonHRSpecDestList = RemoveFromList("PMSS" +SpecTypeInitial+"_"+waveNameSuffix+"_",nonHRSpecDestList, "/") 	
		nonHRSpecDestList = ReplaceString("family", nonHRSpecDestList, "fam")	
		returnList=nonHRSpecDestList
		nonSpecParamStr+="specList:"+specList + ";"
		nonSpecParamStr+="destList:"+nonHRSpecDestList + ";"
		nonSpecParamStr+="HRSpec_flag:0;"
		squirrel_fetch(todo,PK_MS_concentration, 	nonSpecParamStr+paramStrPartial, spectraType)
		if (HR_checkAvgHRMS_UMR)		// we need to sum to unit mass
			HRSpecDestList = PK_sumToUMR(specList, nonHRSpecDestList, specTypeInitial, waveNameSuffix, "")  //1.22A
		endif
	endif
 	
	// for HRspecies
	HRSpec = HR_CheckListForHRSpecies(HRResults_ionList, 4)		// get list for HR masses and families, not for individual spectra
	if (strlen(HRSpec)>0)
	 	HR_getParamStr(SpecParamStr,HRSpec, 1, 0)			//1.11G bug, we want to set the MS flag to 1 not zero.	//1.06E
		specList = StringByKey("specList", SpecParamStr) 	 	
//		sq_dataDestStr(HRSpecDestList,prefix,"av_"+waveNameSuffix,HRSpec,0)
		HRSpecDestList ="PMSS" +SpecTypeInitial+"_"+waveNameSuffix+"_"+ReplaceString("/", specList, "/PMSS" +SpecTypeInitial+"_"+waveNameSuffix+"_")
		HRSpecDestList = RemoveFromList("PMSS" +SpecTypeInitial+"_"+waveNameSuffix+"_",HRSpecDestList, "/") 	
		returnList +=HRSpecDestList
		SpecParamStr += "specList:"+specList + ";"
		SpecParamStr += "destList:"+HRSpecDestList+";"		
		SpecParamStr += "HRSpec_flag:1;"
		squirrel_fetch(todo,PK_MS_concentration, SpecParamStr +paramStrPartial, spectraType)
		if (HR_checkAvgHRMS_UMR)		// we need to sum to unit mass
			HRSpecDestList = PK_sumToUMR(specList, HRSpecDestList, specTypeInitial, waveNameSuffix, "")  //1.22A
		endif
	endif

	if (strlen(nonHRSpec)==0 && strlen(HRSpec)==0 )
		abort "You must select one or more HR species.  Aborting from HR_calc_PTOFSizeDist"
	endif

	returnList = replaceString(";", returnList, "")
	if (tof1_datatype==1)  // if dLog
		sq_ApplyDeltaLogDiam(returnList, HRPToFMxXaxis[%deltalogdEdges]) 	
	endif
		
	return returnList
End			
